Attribute VB_Name = "modD2D1Effects"
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2022
' https://docs.microsoft.com/en-us/windows/win32/direct2d/built-in-effects

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const PICTURE_TRANSPARENT As Long = &H2&
Private Const PAGE_EXECUTE_READWRITE As Long = &H40&

Private Const D3D_FEATURE_LEVEL_9_1 As Long = &H9100&
Private Const D3D_FEATURE_LEVEL_10_0 As Long = &HA000&
Private Const WINCODEC_SDK_VERSION2 As Long = &H237&

Private Const GUID_WICPixelFormat32bppPBGRA As String = "{6fddc324-4e03-4bfe-b185-3d77768dc910}"

Private Const IID_IPicture As String = "{7bf80980-bf32-101a-8bbb-00aa00300cab}"
Private Const IID_ID2D1Image As String = "{65019f75-8da2-497c-b32c-dfa34e48ede6}"
Private Const IID_ID2D1Factory As String = "{06152247-6f50-465a-9245-118bfd3b6007}"
Private Const IID_ID2D1DeviceContext2 As String = "{394ea6a3-0c34-4321-950b-6ca20f0be6c7}"

Private Const CLSID_D2D1Tint As String = "{36312b17-f7dd-4014-915d-ffca768cf211}"
Private Const CLSID_D2D1Crop As String = "{e23f7110-0e9a-4324-af47-6a2c0c46f35b}"
Private Const CLSID_D2D1Tile As String = "{b0784138-3b76-4bc5-b13b-0fa2ad02659f}"
Private Const CLSID_D2D1YCbCr As String = "{99503cc1-66c7-45c9-a875-8ad8a7914401}"
Private Const CLSID_D2D1Atlas As String = "{913e2be4-fdcf-4fe2-a5f0-2454f14ff408}"
Private Const CLSID_D2D1Blend As String = "{81c5b77b-13f8-4cdd-ad20-c890547ac65d}"
Private Const CLSID_D2D1Flood As String = "{61c23c20-ae69-4d8e-94cf-50078df638f2}"
Private Const CLSID_D2D1Sepia As String = "{3a1af410-5f1d-4dbe-84df-915da79b7153}"
Private Const CLSID_D2D1Scale As String = "{9daf9369-3846-4d0e-a44e-0c607934a5d7}"
Private Const CLSID_D2D1Shadow As String = "{c67ea361-1863-4e69-89db-695d3e9a5b6b}"
Private Const CLSID_D2D1Border As String = "{2a2d49c0-4acf-43c7-8c6a-7c4a27874d27}"
Private Const CLSID_D2D1Emboss As String = "{b1c5eb2b-0348-43f0-8107-4957cacba2ae}"
Private Const CLSID_D2D1Invert As String = "{e0c3784d-cb39-4e84-b6fd-6b72f0810263}"
Private Const CLSID_D2D1Sharpen As String = "{c9b887cb-c5ff-4dc5-9779-273dcf417c7d}"
Private Const CLSID_D2D1Opacity As String = "{811d79a4-de28-4454-8094-c64685f8bd4c}"
Private Const CLSID_D2D1Exposure As String = "{b56c8cfa-f634-41ee-bee0-ffa617106004}"
Private Const CLSID_D2D1Vignette As String = "{c00c40be-5e67-4ca3-95b4-f4b02c115135}"
Private Const CLSID_D2D1Contrast As String = "{b648a78a-0ed5-4f80-a94a-8e825aca6b77}"
Private Const CLSID_D2D1RgbToHue As String = "{23f3e5ec-91e8-4d3d-ad0a-afadc1004aa1}"
Private Const CLSID_D2D1HueToRgb As String = "{7b78a6bd-0141-4def-8a52-6356ee0cbdd5}"
Private Const CLSID_D2D1CrossFade As String = "{12f575e8-4db1-485f-9a84-03a07dd3829f}"
Private Const CLSID_D2D1AlphaMask As String = "{c80ecff0-3fd5-4f05-8328-c5d1724b4f0a}"
Private Const CLSID_D2D1Posterize As String = "{2188945e-33a3-4366-b7bc-086bd02d0884}"
Private Const CLSID_D2D1Grayscale As String = "{36dde0eb-3725-42e0-836d-52fb20aee644}"
Private Const CLSID_D2D1ChromaKey As String = "{74c01f5b-2a0d-408c-88e2-c7a3c7197742}"
Private Const CLSID_D2D1Composite As String = "{48fc9f51-f6ac-48f1-8b58-3b28ac46f76d}"
Private Const CLSID_D2D1Histogram As String = "{881db7d0-f7ee-4d4d-a6d2-4697acc66ee8}"
Private Const CLSID_D2D1HdrToneMap As String = "{7b0b748d-4610-4486-a90c-999d9a2e2b11}"
Private Const CLSID_D2D1Saturation As String = "{5cb2d9cf-327d-459f-a0ce-40c0b2086bf7}"
Private Const CLSID_D2D1Straighten As String = "{4da47b12-79a3-4fb0-8237-bbc3b2a4de08}"
Private Const CLSID_D2D1Brightness As String = "{8cea8d1e-77b0-4986-b3b9-2f0c0eae7887}"
Private Const CLSID_D2D1Morphology As String = "{eae6c40d-626a-4c2d-bfcb-391001abe202}"
Private Const CLSID_D2D1Turbulence As String = "{cf2bb6ae-889a-4ad7-ba29-a2fd732c9fc9}"
Private Const CLSID_D2D1Premultiply As String = "{06eab419-deed-4018-80d2-3e1d471adeb2}"
Private Const CLSID_D2D1HueRotation As String = "{0f4458ec-4b32-491b-9e85-bd73f44d3eb6}"
Private Const CLSID_D2D1SpotDiffuse As String = "{818a1105-7932-44f4-aa86-08ae7b2f2c93}"
Private Const CLSID_D2D1ColorMatrix As String = "{921f03d6-641c-47df-852d-b4bb6153ae11}"
Private Const CLSID_D2D13DTransform As String = "{e8467b04-ec61-4b8a-b5de-d4d73debea5a}"
Private Const CLSID_D2D1GaussianBlur As String = "{1feb6d69-2fe6-4ac9-8c58-1d7f93e7a6a5}"
Private Const CLSID_D2D1BitmapSource As String = "{5fb6c24d-c6dd-4231-9404-50f4d5c3252d}"
Private Const CLSID_D2D1PointDiffuse As String = "{b9e303c3-c08c-4f91-8b7b-38656bc48c20}"
Private Const CLSID_D2D1SpotSpecular As String = "{edae421e-7654-4a37-9db8-71acc1beb3c1}"
Private Const CLSID_D2D1EdgeDetection As String = "{eff583ca-cb07-4aa9-ac5d-2cc44c76460f}"
Private Const CLSID_D2D1TableTransfer As String = "{5bf818c3-5e43-48cb-b631-868396d6a1d4}"
Private Const CLSID_D2D1GammaTransfer As String = "{409444c4-c419-41a0-b0c1-8cd0c0a18e42}"
Private Const CLSID_D2D1UnPremultiply As String = "{fb9ac489-ad8d-41ed-9999-bb6347d110f7}"
Private Const CLSID_D2D1PointSpecular As String = "{09c3ca26-3ae2-4f09-9ebc-ed3865d53f22}"
Private Const CLSID_D2D1LookupTable3D As String = "{349e0eda-0088-4a79-9ca3-c7e300202020}"
Private Const CLSID_D2D1LinearTransfer As String = "{ad47c8fd-63ef-4acc-9b51-67979c036c06}"
Private Const CLSID_D2D1ConvolveMatrix As String = "{407f8c08-5533-4331-a341-23cc3877843e}"
Private Const CLSID_D2D1DistantDiffuse As String = "{3e7efd62-a32d-46d4-a83c-5278889ac954}"
Private Const CLSID_D2D1ColorManagement As String = "{1a28524c-fdd6-4aa4-ae8f-837eb8267b37}"
Private Const CLSID_D2D1DpiCompensation As String = "{6c26c5c7-34e0-46fc-9cfd-e5823706e228}"
Private Const CLSID_D2D1DirectionalBlur As String = "{174319a6-58e9-49b2-bb63-caf2c811a3db}"
Private Const CLSID_D2D1TemperatureTint As String = "{89176087-8af9-4a08-aeb1-895f38db1766}"
Private Const CLSID_D2D1DisplacementMap As String = "{edc48364-0417-4111-9450-43845fa9f890}"
Private Const CLSID_D2D1DistantSpecular As String = "{428c1ee5-77b8-4450-8ab5-72219c21abda}"
Private Const CLSID_D2D1OpacityMetadata As String = "{6c53006a-4450-4199-aa5b-ad1656fece5e}"
Private Const CLSID_D2D1DiscreteTransfer As String = "{90866fcd-488e-454b-af06-e5041b66c36c}"
Private Const CLSID_D2D1LuminanceToAlpha As String = "{41251ab7-0beb-46f8-9da7-59e93fcce5de}"
Private Const CLSID_D2D1HighlightsShadows As String = "{cadc8384-323f-4c7e-a361-2e2b24df6ee4}"
Private Const CLSID_D2D12DAffineTransform As String = "{6aa97485-6354-4cfc-908c-e4a74f62c96c}"
Private Const CLSID_D2D1ArithmeticComposite As String = "{fc151437-049a-4784-a24a-f1c4daf20987}"
Private Const CLSID_D2D1WhiteLevelAdjustment As String = "{44a1cadb-6cdd-4818-8ff4-26c1cfe95bdb}"
Private Const CLSID_D2D13DPerspectiveTransform As String = "{c2844d0b-3d86-46e7-85ba-526c9240f3fb}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IUnknown
    QueryInterface = 0
    
    ' ID2D1Factory
    CreateWicBitmapRenderTarget = 13
    
    ' ID2D1DeviceContext2
    Clear = 47
    BeginDraw = 48
    EndDraw = 49
    CreateColorContext = 59
    CreateEffect = 63
    GetImageLocalBounds = 70
    DrawImage = 83
    CreateLookupTable3D = 99
    
    ' ID2D1Effect
    SetValue = 9
    GetValue = 11
    SetInput = 14
    GetOutput = 18
    
End Enum

Private Enum WICAccessOption
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Private Enum WICDecodeOptions
    WICDecodeMetadataCacheOnDemand = 0
    WICDecodeMetadataCacheOnLoad = 1
End Enum

Private Enum WICBitmapCreateCacheOption
    WICBitmapNoCache = 0
    WICBitmapCacheOnDemand = 1
    WICBitmapCacheOnLoad = 2
End Enum

Private Enum WICBitmapLockFlags
    WICBitmapLockRead = 1
    WICBitmapLockWrite = 2
End Enum

Private Enum WICBitmapAlphaChannelOption
    WICBitmapUseAlpha = 0
    WICBitmapUsePremultipliedAlpha = 1
    WICBitmapIgnoreAlpha = 2
End Enum

Private Enum DXGI_FORMAT
    DXGI_FORMAT_UNKNOWN = 0
    DXGI_FORMAT_R32G32B32A32_TYPELESS = 1
    DXGI_FORMAT_R32G32B32A32_FLOAT = 2
    DXGI_FORMAT_R32G32B32A32_UINT = 3
    DXGI_FORMAT_R32G32B32A32_SINT = 4
    DXGI_FORMAT_R32G32B32_TYPELESS = 5
    DXGI_FORMAT_R32G32B32_FLOAT = 6
    DXGI_FORMAT_R32G32B32_UINT = 7
    DXGI_FORMAT_R32G32B32_SINT = 8
    DXGI_FORMAT_R16G16B16A16_TYPELESS = 9
    DXGI_FORMAT_R16G16B16A16_FLOAT = 10
    DXGI_FORMAT_R16G16B16A16_UNORM = 11
    DXGI_FORMAT_R16G16B16A16_UINT = 12
    DXGI_FORMAT_R16G16B16A16_SNORM = 13
    DXGI_FORMAT_R16G16B16A16_SINT = 14
    DXGI_FORMAT_R32G32_TYPELESS = 15
    DXGI_FORMAT_R32G32_FLOAT = 16
    DXGI_FORMAT_R32G32_UINT = 17
    DXGI_FORMAT_R32G32_SINT = 18
    DXGI_FORMAT_R32G8X24_TYPELESS = 19
    DXGI_FORMAT_D32_FLOAT_S8X24_UINT = 20
    DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS = 21
    DXGI_FORMAT_X32_TYPELESS_G8X24_UINT = 22
    DXGI_FORMAT_R10G10B10A2_TYPELESS = 23
    DXGI_FORMAT_R10G10B10A2_UNORM = 24
    DXGI_FORMAT_R10G10B10A2_UINT = 25
    DXGI_FORMAT_R11G11B10_FLOAT = 26
    DXGI_FORMAT_R8G8B8A8_TYPELESS = 27
    DXGI_FORMAT_R8G8B8A8_UNORM = 28
    DXGI_FORMAT_R8G8B8A8_UNORM_SRGB = 29
    DXGI_FORMAT_R8G8B8A8_UINT = 30
    DXGI_FORMAT_R8G8B8A8_SNORM = 31
    DXGI_FORMAT_R8G8B8A8_SINT = 32
    DXGI_FORMAT_R16G16_TYPELESS = 33
    DXGI_FORMAT_R16G16_FLOAT = 34
    DXGI_FORMAT_R16G16_UNORM = 35
    DXGI_FORMAT_R16G16_UINT = 36
    DXGI_FORMAT_R16G16_SNORM = 37
    DXGI_FORMAT_R16G16_SINT = 38
    DXGI_FORMAT_R32_TYPELESS = 39
    DXGI_FORMAT_D32_FLOAT = 40
    DXGI_FORMAT_R32_FLOAT = 41
    DXGI_FORMAT_R32_UINT = 42
    DXGI_FORMAT_R32_SINT = 43
    DXGI_FORMAT_R24G8_TYPELESS = 44
    DXGI_FORMAT_D24_UNORM_S8_UINT = 45
    DXGI_FORMAT_R24_UNORM_X8_TYPELESS = 46
    DXGI_FORMAT_X24_TYPELESS_G8_UINT = 47
    DXGI_FORMAT_R8G8_TYPELESS = 48
    DXGI_FORMAT_R8G8_UNORM = 49
    DXGI_FORMAT_R8G8_UINT = 50
    DXGI_FORMAT_R8G8_SNORM = 51
    DXGI_FORMAT_R8G8_SINT = 52
    DXGI_FORMAT_R16_TYPELESS = 53
    DXGI_FORMAT_R16_FLOAT = 54
    DXGI_FORMAT_D16_UNORM = 55
    DXGI_FORMAT_R16_UNORM = 56
    DXGI_FORMAT_R16_UINT = 57
    DXGI_FORMAT_R16_SNORM = 58
    DXGI_FORMAT_R16_SINT = 59
    DXGI_FORMAT_R8_TYPELESS = 60
    DXGI_FORMAT_R8_UNORM = 61
    DXGI_FORMAT_R8_UINT = 62
    DXGI_FORMAT_R8_SNORM = 63
    DXGI_FORMAT_R8_SINT = 64
    DXGI_FORMAT_A8_UNORM = 65
    DXGI_FORMAT_R1_UNORM = 66
    DXGI_FORMAT_R9G9B9E5_SHAREDEXP = 67
    DXGI_FORMAT_R8G8_B8G8_UNORM = 68
    DXGI_FORMAT_G8R8_G8B8_UNORM = 69
    DXGI_FORMAT_BC1_TYPELESS = 70
    DXGI_FORMAT_BC1_UNORM = 71
    DXGI_FORMAT_BC1_UNORM_SRGB = 72
    DXGI_FORMAT_BC2_TYPELESS = 73
    DXGI_FORMAT_BC2_UNORM = 74
    DXGI_FORMAT_BC2_UNORM_SRGB = 75
    DXGI_FORMAT_BC3_TYPELESS = 76
    DXGI_FORMAT_BC3_UNORM = 77
    DXGI_FORMAT_BC3_UNORM_SRGB = 78
    DXGI_FORMAT_BC4_TYPELESS = 79
    DXGI_FORMAT_BC4_UNORM = 80
    DXGI_FORMAT_BC4_SNORM = 81
    DXGI_FORMAT_BC5_TYPELESS = 82
    DXGI_FORMAT_BC5_UNORM = 83
    DXGI_FORMAT_BC5_SNORM = 84
    DXGI_FORMAT_B5G6R5_UNORM = 85
    DXGI_FORMAT_B5G5R5A1_UNORM = 86
    DXGI_FORMAT_B8G8R8A8_UNORM = 87
    DXGI_FORMAT_B8G8R8X8_UNORM = 88
    DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM = 89
    DXGI_FORMAT_B8G8R8A8_TYPELESS = 90
    DXGI_FORMAT_B8G8R8A8_UNORM_SRGB = 91
    DXGI_FORMAT_B8G8R8X8_TYPELESS = 92
    DXGI_FORMAT_B8G8R8X8_UNORM_SRGB = 93
    DXGI_FORMAT_BC6H_TYPELESS = 94
    DXGI_FORMAT_BC6H_UF16 = 95
    DXGI_FORMAT_BC6H_SF16 = 96
    DXGI_FORMAT_BC7_TYPELESS = 97
    DXGI_FORMAT_BC7_UNORM = 98
    DXGI_FORMAT_BC7_UNORM_SRGB = 99
    DXGI_FORMAT_AYUV = 100
    DXGI_FORMAT_Y410 = 101
    DXGI_FORMAT_Y416 = 102
    DXGI_FORMAT_NV12 = 103
    DXGI_FORMAT_P010 = 104
    DXGI_FORMAT_P016 = 105
    DXGI_FORMAT_420_OPAQUE = 106
    DXGI_FORMAT_YUY2 = 107
    DXGI_FORMAT_Y210 = 108
    DXGI_FORMAT_Y216 = 109
    DXGI_FORMAT_NV11 = 110
    DXGI_FORMAT_AI44 = 111
    DXGI_FORMAT_IA44 = 112
    DXGI_FORMAT_P8 = 113
    DXGI_FORMAT_A8P8 = 114
    DXGI_FORMAT_B4G4R4A4_UNORM = 115
    DXGI_FORMAT_P208 = 130
    DXGI_FORMAT_V208 = 131
    DXGI_FORMAT_V408 = 132
End Enum

Private Enum D2D1_FACTORY_TYPE
    D2D1_FACTORY_TYPE_SINGLE_THREADED = 0
    D2D1_FACTORY_TYPE_MULTI_THREADED = 1
End Enum

Private Enum D2D1_DEBUG_LEVEL
    D2D1_DEBUG_LEVEL_NONE = 0
    D2D1_DEBUG_LEVEL_ERROR = 1
    D2D1_DEBUG_LEVEL_WARNING = 2
    D2D1_DEBUG_LEVEL_INFORMATION = 3
End Enum

Private Enum D2D1_RENDER_TARGET_TYPE
    D2D1_RENDER_TARGET_TYPE_DEFAULT = 0
    D2D1_RENDER_TARGET_TYPE_SOFTWARE = 1
    D2D1_RENDER_TARGET_TYPE_HARDWARE = 2
End Enum

Private Enum D2D1_RENDER_TARGET_USAGE
    D2D1_RENDER_TARGET_USAGE_NONE = 0
    D2D1_RENDER_TARGET_USAGE_FORCE_BITMAP_REMOTING = 1
    D2D1_RENDER_TARGET_USAGE_GDI_COMPATIBLE = 2
End Enum

Private Enum D2D1_FEATURE_LEVEL
    D2D1_FEATURE_LEVEL_DEFAULT = 0
    D2D1_FEATURE_LEVEL_9 = D3D_FEATURE_LEVEL_9_1
    D2D1_FEATURE_LEVEL_10 = D3D_FEATURE_LEVEL_10_0
End Enum

Public Enum D2D1_ALPHA_MODE
    D2D1_ALPHA_MODE_UNKNOWN = 0
    D2D1_ALPHA_MODE_PREMULTIPLIED = 1
    D2D1_ALPHA_MODE_STRAIGHT = 2
    D2D1_ALPHA_MODE_IGNORE = 3
End Enum

Public Enum D2D1_BITMAPSOURCE_ORIENTATION
    D2D1_BITMAPSOURCE_ORIENTATION_DEFAULT = 1
    D2D1_BITMAPSOURCE_ORIENTATION_FLIP_HORIZONTAL = 2
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE180 = 3
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE180_FLIP_HORIZONTAL = 4
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE270_FLIP_HORIZONTAL = 5
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE90 = 6
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE90_FLIP_HORIZONTAL = 7
    D2D1_BITMAPSOURCE_ORIENTATION_ROTATE_CLOCKWISE270 = 8
End Enum

Public Enum D2D1_BITMAPSOURCE_INTERPOLATION_MODE
    D2D1_BITMAPSOURCE_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_BITMAPSOURCE_INTERPOLATION_MODE_LINEAR = 1
    D2D1_BITMAPSOURCE_INTERPOLATION_MODE_CUBIC = 2
    D2D1_BITMAPSOURCE_INTERPOLATION_MODE_FANT = 6
    D2D1_BITMAPSOURCE_INTERPOLATION_MODE_MIPMAP_LINEAR = 7
End Enum

Public Enum D2D1_BITMAPSOURCE_ALPHA_MODE
    D2D1_BITMAPSOURCE_ALPHA_MODE_PREMULTIPLIED = 1
    D2D1_BITMAPSOURCE_ALPHA_MODE_STRAIGHT = 2
End Enum

Private Enum D2D1_PROPERTY_TYPE
    D2D1_PROPERTY_TYPE_UNKNOWN = 0
    D2D1_PROPERTY_TYPE_STRING = 1
    D2D1_PROPERTY_TYPE_BOOL = 2
    D2D1_PROPERTY_TYPE_UINT32 = 3
    D2D1_PROPERTY_TYPE_INT32 = 4
    D2D1_PROPERTY_TYPE_FLOAT = 5
    D2D1_PROPERTY_TYPE_VECTOR2 = 6
    D2D1_PROPERTY_TYPE_VECTOR3 = 7
    D2D1_PROPERTY_TYPE_VECTOR4 = 8
    D2D1_PROPERTY_TYPE_BLOB = 9
    D2D1_PROPERTY_TYPE_IUNKNOWN = 10
    D2D1_PROPERTY_TYPE_ENUM = 11
    D2D1_PROPERTY_TYPE_ARRAY = 12
    D2D1_PROPERTY_TYPE_CLSID = 13
    D2D1_PROPERTY_TYPE_MATRIX_3X2 = 14
    D2D1_PROPERTY_TYPE_MATRIX_4X3 = 15
    D2D1_PROPERTY_TYPE_MATRIX_4X4 = 16
    D2D1_PROPERTY_TYPE_MATRIX_5X4 = 17
    D2D1_PROPERTY_TYPE_COLOR_CONTEXT = 18
End Enum

Private Enum D2D1_INTERPOLATION_MODE
    D2D1_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_INTERPOLATION_MODE_LINEAR = 1
    D2D1_INTERPOLATION_MODE_CUBIC = 2
    D2D1_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_INTERPOLATION_MODE_ANISOTROPIC = 4
    D2D1_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_COLOR_SPACE
    ' D2D1_COLOR_SPACE_CUSTOM = 0
    D2D1_COLOR_SPACE_SRGB = 1
    D2D1_COLOR_SPACE_SCRGB = 2
End Enum

Public Enum D2D1_COLORMANAGEMENT_RENDERING_INTENT
    D2D1_COLORMANAGEMENT_RENDERING_INTENT_PERCEPTUAL = 0
    D2D1_COLORMANAGEMENT_RENDERING_INTENT_RELATIVE_COLORIMETRIC = 1
    D2D1_COLORMANAGEMENT_RENDERING_INTENT_SATURATION = 2
    D2D1_COLORMANAGEMENT_RENDERING_INTENT_ABSOLUTE_COLORIMETRIC = 3
End Enum
    
Public Enum D2D1_COLORMANAGEMENT_ALPHA_MODE
    D2D1_COLORMANAGEMENT_ALPHA_MODE_PREMULTIPLIED = 1
    D2D1_COLORMANAGEMENT_ALPHA_MODE_STRAIGHT = 2
End Enum

Public Enum D2D1_COLORMANAGEMENT_QUALITY
    D2D1_COLORMANAGEMENT_QUALITY_PROOF = 0
    D2D1_COLORMANAGEMENT_QUALITY_NORMAL = 1
    D2D1_COLORMANAGEMENT_QUALITY_BEST = 2
End Enum

Public Enum D2D1_COMPOSITE_MODE
    D2D1_COMPOSITE_MODE_SOURCE_OVER = 0
    D2D1_COMPOSITE_MODE_DESTINATION_OVER = 1
    D2D1_COMPOSITE_MODE_SOURCE_IN = 2
    D2D1_COMPOSITE_MODE_DESTINATION_IN = 3
    D2D1_COMPOSITE_MODE_SOURCE_OUT = 4
    D2D1_COMPOSITE_MODE_DESTINATION_OUT = 5
    D2D1_COMPOSITE_MODE_SOURCE_ATOP = 6
    D2D1_COMPOSITE_MODE_DESTINATION_ATOP = 7
    D2D1_COMPOSITE_MODE_XOR = 8
    D2D1_COMPOSITE_MODE_PLUS = 9
    D2D1_COMPOSITE_MODE_SOURCE_COPY = 10
    D2D1_COMPOSITE_MODE_BOUNDED_SOURCE_COPY = 11
    D2D1_COMPOSITE_MODE_MASK_INVERT = 12
End Enum

Public Enum D2D1_BORDER_EDGE_MODE
    D2D1_BORDER_EDGE_MODE_CLAMP = 0
    D2D1_BORDER_EDGE_MODE_WRAP = 1
    D2D1_BORDER_EDGE_MODE_MIRROR = 2
End Enum

Public Enum D2D1_BORDER_MODE
    D2D1_BORDER_MODE_SOFT = 0
    D2D1_BORDER_MODE_HARD = 1
End Enum

Public Enum D2D1_BLEND_MODE
    D2D1_BLEND_MODE_MULTIPLY = 0
    D2D1_BLEND_MODE_SCREEN = 1
    D2D1_BLEND_MODE_DARKEN = 2
    D2D1_BLEND_MODE_LIGHTEN = 3
    D2D1_BLEND_MODE_DISSOLVE = 4
    D2D1_BLEND_MODE_COLOR_BURN = 5
    D2D1_BLEND_MODE_LINEAR_BURN = 6
    D2D1_BLEND_MODE_DARKER_COLOR = 7
    D2D1_BLEND_MODE_LIGHTER_COLOR = 8
    D2D1_BLEND_MODE_COLOR_DODGE = 9
    D2D1_BLEND_MODE_LINEAR_DODGE = 10
    D2D1_BLEND_MODE_OVERLAY = 11
    D2D1_BLEND_MODE_SOFT_LIGHT = 12
    D2D1_BLEND_MODE_HARD_LIGHT = 13
    D2D1_BLEND_MODE_VIVID_LIGHT = 14
    D2D1_BLEND_MODE_LINEAR_LIGHT = 15
    D2D1_BLEND_MODE_PIN_LIGHT = 16
    D2D1_BLEND_MODE_HARD_MIX = 17
    D2D1_BLEND_MODE_DIFFERENCE = 18
    D2D1_BLEND_MODE_EXCLUSION = 19
    D2D1_BLEND_MODE_HUE = 20
    D2D1_BLEND_MODE_SATURATION = 21
    D2D1_BLEND_MODE_COLOR = 22
    D2D1_BLEND_MODE_LUMINOSITY = 23
    D2D1_BLEND_MODE_SUBTRACT = 24
    D2D1_BLEND_MODE_DIVISION = 25
End Enum

Public Enum D2D1_RGBTOHUE_OUTPUT_COLOR_SPACE
    D2D1_RGBTOHUE_OUTPUT_COLOR_SPACE_HUE_SATURATION_VALUE = 0
    D2D1_RGBTOHUE_OUTPUT_COLOR_SPACE_HUE_SATURATION_LIGHTNESS = 1
End Enum

Public Enum D2D1_HUETORGB_INPUT_COLOR_SPACE
    D2D1_HUETORGB_INPUT_COLOR_SPACE_HUE_SATURATION_VALUE = 0
    D2D1_HUETORGB_INPUT_COLOR_SPACE_HUE_SATURATION_LIGHTNESS = 1
End Enum

Public Enum D2D1_STRAIGHTEN_SCALE_MODE
    D2D1_STRAIGHTEN_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_STRAIGHTEN_SCALE_MODE_LINEAR = 1
    D2D1_STRAIGHTEN_SCALE_MODE_CUBIC = 2
    D2D1_STRAIGHTEN_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_STRAIGHTEN_SCALE_MODE_ANISOTROPIC = 4
End Enum

Public Enum D2D1_MORPHOLOGY_MODE
    D2D1_MORPHOLOGY_MODE_ERODE = 0
    D2D1_MORPHOLOGY_MODE_DILATE = 1
End Enum
        
Public Enum D2D1_TURBULENCE_NOISE
    D2D1_TURBULENCE_NOISE_FRACTAL_SUM = 0
    D2D1_TURBULENCE_NOISE_TURBULENCE = 1
End Enum

Public Enum D2D1_EDGEDETECTION_MODE
    D2D1_EDGEDETECTION_MODE_SOBEL = 0
    D2D1_EDGEDETECTION_MODE_PREWITT = 1
End Enum

Public Enum D2D1_CONVOLVEMATRIX_SCALE_MODE
    D2D1_CONVOLVEMATRIX_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_CONVOLVEMATRIX_SCALE_MODE_LINEAR = 1
    D2D1_CONVOLVEMATRIX_SCALE_MODE_CUBIC = 2
    D2D1_CONVOLVEMATRIX_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_CONVOLVEMATRIX_SCALE_MODE_ANISOTROPIC = 4
    D2D1_CONVOLVEMATRIX_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_DISTANTDIFFUSE_SCALE_MODE
    D2D1_DISTANTDIFFUSE_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_DISTANTDIFFUSE_SCALE_MODE_LINEAR = 1
    D2D1_DISTANTDIFFUSE_SCALE_MODE_CUBIC = 2
    D2D1_DISTANTDIFFUSE_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_DISTANTDIFFUSE_SCALE_MODE_ANISOTROPIC = 4
    D2D1_DISTANTDIFFUSE_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_DISTANTSPECULAR_SCALE_MODE
    D2D1_DISTANTSPECULAR_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_DISTANTSPECULAR_SCALE_MODE_LINEAR = 1
    D2D1_DISTANTSPECULAR_SCALE_MODE_CUBIC = 2
    D2D1_DISTANTSPECULAR_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_DISTANTSPECULAR_SCALE_MODE_ANISOTROPIC = 4
    D2D1_DISTANTSPECULAR_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_DIRECTIONALBLUR_OPTIMIZATION
    D2D1_DIRECTIONALBLUR_OPTIMIZATION_SPEED = 0
    D2D1_DIRECTIONALBLUR_OPTIMIZATION_BALANCED = 1
    D2D1_DIRECTIONALBLUR_OPTIMIZATION_QUALITY = 2
End Enum

Public Enum D2D1_CHANNEL_SELECTOR
    D2D1_CHANNEL_SELECTOR_R = 0
    D2D1_CHANNEL_SELECTOR_G = 1
    D2D1_CHANNEL_SELECTOR_B = 2
    D2D1_CHANNEL_SELECTOR_A = 3
End Enum

Public Enum D2D1_HIGHLIGHTSANDSHADOWS_INPUT_GAMMA
    D2D1_HIGHLIGHTSANDSHADOWS_INPUT_GAMMA_LINEAR = 0
    D2D1_HIGHLIGHTSANDSHADOWS_INPUT_GAMMA_SRGB = 1
End Enum

Public Enum D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_LINEAR = 1
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_CUBIC = 2
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC = 4
    D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_SCALE_INTERPOLATION_MODE
    D2D1_SCALE_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_SCALE_INTERPOLATION_MODE_LINEAR = 1
    D2D1_SCALE_INTERPOLATION_MODE_CUBIC = 2
    D2D1_SCALE_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_SCALE_INTERPOLATION_MODE_ANISOTROPIC = 4
    D2D1_SCALE_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_GAUSSIANBLUR_OPTIMIZATION
    D2D1_GAUSSIANBLUR_OPTIMIZATION_SPEED = 0
    D2D1_GAUSSIANBLUR_OPTIMIZATION_BALANCED = 1
    D2D1_GAUSSIANBLUR_OPTIMIZATION_QUALITY = 2
End Enum

Public Enum D2D1_SHADOW_OPTIMIZATION
    D2D1_SHADOW_OPTIMIZATION_SPEED = 0
    D2D1_SHADOW_OPTIMIZATION_BALANCED = 1
    D2D1_SHADOW_OPTIMIZATION_QUALITY = 2
End Enum

Public Enum D2D1_DPICOMPENSATION_INTERPOLATION_MODE
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_LINEAR = 1
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_CUBIC = 2
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_ANISOTROPIC = 4
    D2D1_DPICOMPENSATION_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_POINTDIFFUSE_SCALE_MODE
    D2D1_POINTDIFFUSE_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_POINTDIFFUSE_SCALE_MODE_LINEAR = 1
    D2D1_POINTDIFFUSE_SCALE_MODE_CUBIC = 2
    D2D1_POINTDIFFUSE_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_POINTDIFFUSE_SCALE_MODE_ANISOTROPIC = 4
    D2D1_POINTDIFFUSE_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_POINTSPECULAR_SCALE_MODE
    D2D1_POINTSPECULAR_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_POINTSPECULAR_SCALE_MODE_LINEAR = 1
    D2D1_POINTSPECULAR_SCALE_MODE_CUBIC = 2
    D2D1_POINTSPECULAR_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_POINTSPECULAR_SCALE_MODE_ANISOTROPIC = 4
    D2D1_POINTSPECULAR_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_SPOTDIFFUSE_SCALE_MODE
    D2D1_SPOTDIFFUSE_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_SPOTDIFFUSE_SCALE_MODE_LINEAR = 1
    D2D1_SPOTDIFFUSE_SCALE_MODE_CUBIC = 2
    D2D1_SPOTDIFFUSE_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_SPOTDIFFUSE_SCALE_MODE_ANISOTROPIC = 4
    D2D1_SPOTDIFFUSE_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_SPOTSPECULAR_SCALE_MODE
    D2D1_SPOTSPECULAR_SCALE_MODE_NEAREST_NEIGHBOR = 0
    D2D1_SPOTSPECULAR_SCALE_MODE_LINEAR = 1
    D2D1_SPOTSPECULAR_SCALE_MODE_CUBIC = 2
    D2D1_SPOTSPECULAR_SCALE_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_SPOTSPECULAR_SCALE_MODE_ANISOTROPIC = 4
    D2D1_SPOTSPECULAR_SCALE_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Public Enum D2D1_HDRTONEMAP_DISPLAY_MODE
    D2D1_HDRTONEMAP_DISPLAY_MODE_SDR = 0
    D2D1_HDRTONEMAP_DISPLAY_MODE_HDR = 1
End Enum

Public Enum D2D1_COLORMATRIX_ALPHA_MODE
    D2D1_COLORMATRIX_ALPHA_MODE_PREMULTIPLIED = 1
    D2D1_COLORMATRIX_ALPHA_MODE_STRAIGHT = 2
End Enum

Public Enum D2D1_3DTRANSFORM_INTERPOLATION_MODE
    D2D1_3DTRANSFORM_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_3DTRANSFORM_INTERPOLATION_MODE_LINEAR = 1
    D2D1_3DTRANSFORM_INTERPOLATION_MODE_CUBIC = 2
    D2D1_3DTRANSFORM_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_3DTRANSFORM_INTERPOLATION_MODE_ANISOTROPIC = 4
End Enum

Public Enum D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE
    D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_LINEAR = 1
    D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_CUBIC = 2
    D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_ANISOTROPIC = 4
End Enum

Public Enum D2D1_YCBCR_CHROMA_SUBSAMPLING
    D2D1_YCBCR_CHROMA_SUBSAMPLING_AUTO = 0
    D2D1_YCBCR_CHROMA_SUBSAMPLING_420 = 1
    D2D1_YCBCR_CHROMA_SUBSAMPLING_422 = 2
    D2D1_YCBCR_CHROMA_SUBSAMPLING_444 = 3
    D2D1_YCBCR_CHROMA_SUBSAMPLING_440 = 4
End Enum

Public Enum D2D1_YCBCR_INTERPOLATION_MODE
    D2D1_YCBCR_INTERPOLATION_MODE_NEAREST_NEIGHBOR = 0
    D2D1_YCBCR_INTERPOLATION_MODE_LINEAR = 1
    D2D1_YCBCR_INTERPOLATION_MODE_CUBIC = 2
    D2D1_YCBCR_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR = 3
    D2D1_YCBCR_INTERPOLATION_MODE_ANISOTROPIC = 4
    D2D1_YCBCR_INTERPOLATION_MODE_HIGH_QUALITY_CUBIC = 5
End Enum

Private Enum D2D1_TINT_PROP
    D2D1_TINT_PROP_COLOR = 0
    D2D1_TINT_PROP_CLAMP_OUTPUT = 1
End Enum

Private Enum D2D1_CROP_PROP
    D2D1_CROP_PROP_RECT = 0
    D2D1_CROP_PROP_BORDER_MODE = 1
End Enum

Private Enum D2D1_TILE_PROP
    D2D1_TILE_PROP_RECT = 0
End Enum
    
Private Enum D2D1_YCBCR_PROP
    D2D1_YCBCR_PROP_CHROMA_SUBSAMPLING = 0
    D2D1_YCBCR_PROP_TRANSFORM_MATRIX = 1
    D2D1_YCBCR_PROP_INTERPOLATION_MODE = 2
End Enum

Private Enum D2D1_ATLAS_PROP
    D2D1_ATLAS_PROP_INPUT_RECT = 0
    D2D1_ATLAS_PROP_INPUT_PADDING_RECT = 1
End Enum

Private Enum D2D1_BLEND_PROP
    D2D1_BLEND_PROP_MODE = 0
End Enum

Private Enum D2D1_FLOOD_PROP
    D2D1_FLOOD_PROP_COLOR = 0
End Enum

Private Enum D2D1_SEPIA_PROP
    D2D1_SEPIA_PROP_INTENSITY = 0
    D2D1_SEPIA_PROP_ALPHA_MODE = 1
End Enum

Private Enum D2D1_SCALE_PROP
    D2D1_SCALE_PROP_SCALE = 0
    D2D1_SCALE_PROP_CENTER_POINT = 1
    D2D1_SCALE_PROP_INTERPOLATION_MODE = 2
    D2D1_SCALE_PROP_BORDER_MODE = 3
    D2D1_SCALE_PROP_SHARPNESS = 4
End Enum

Private Enum D2D1_SHADOW_PROP
    D2D1_SHADOW_PROP_BLUR_STANDARD_DEVIATION = 0
    D2D1_SHADOW_PROP_COLOR = 1
    D2D1_SHADOW_PROP_OPTIMIZATION = 2
End Enum

Private Enum D2D1_BORDER_PROP
    D2D1_BORDER_PROP_EDGE_MODE_X = 0
    D2D1_BORDER_PROP_EDGE_MODE_Y = 1
End Enum

Private Enum D2D1_EMBOSS_PROP
    D2D1_EMBOSS_PROP_HEIGHT = 0
    D2D1_EMBOSS_PROP_DIRECTION = 1
End Enum
        
Private Enum D2D1_SHARPEN_PROP
    D2D1_SHARPEN_PROP_SHARPNESS = 0
    D2D1_SHARPEN_PROP_THRESHOLD = 1
End Enum
        
Private Enum D2D1_OPACITY_PROP
    D2D1_OPACITY_PROP_OPACITY = 0
End Enum

Private Enum D2D1_EXPOSURE_PROP
    D2D1_EXPOSURE_PROP_EXPOSURE_VALUE = 0
End Enum

Private Enum D2D1_VIGNETTE_PROP
    D2D1_VIGNETTE_PROP_COLOR = 0
    D2D1_VIGNETTE_PROP_TRANSITION_SIZE = 1
    D2D1_VIGNETTE_PROP_STRENGTH = 2
End Enum
        
Private Enum D2D1_CONTRAST_PROP
    D2D1_CONTRAST_PROP_CONTRAST = 0
    D2D1_CONTRAST_PROP_CLAMP_INPUT = 1
End Enum

Private Enum D2D1_RGBTOHUE_PROP
    D2D1_RGBTOHUE_PROP_OUTPUT_COLOR_SPACE = 0
End Enum
        
Private Enum D2D1_HUETORGB_PROP
    D2D1_HUETORGB_PROP_INPUT_COLOR_SPACE = 0
End Enum

Private Enum D2D1_HISTOGRAM_PROP
    D2D1_HISTOGRAM_PROP_NUM_BINS = 0
    D2D1_HISTOGRAM_PROP_CHANNEL_SELECT = 1
    D2D1_HISTOGRAM_PROP_HISTOGRAM_OUTPUT = 2
End Enum
    
Private Enum D2D1_CROSSFADE_PROP
    D2D1_CROSSFADE_PROP_WEIGHT = 0
End Enum

Private Enum D2D1_POSTERIZE_PROP
    D2D1_POSTERIZE_PROP_RED_VALUE_COUNT = 0
    D2D1_POSTERIZE_PROP_GREEN_VALUE_COUNT = 1
    D2D1_POSTERIZE_PROP_BLUE_VALUE_COUNT = 2
End Enum

Private Enum D2D1_CHROMAKEY_PROP
    D2D1_CHROMAKEY_PROP_COLOR = 0
    D2D1_CHROMAKEY_PROP_TOLERANCE = 1
    D2D1_CHROMAKEY_PROP_INVERT_ALPHA = 2
    D2D1_CHROMAKEY_PROP_FEATHER = 3
End Enum

Private Enum D2D1_COMPOSITE_PROP
    D2D1_COMPOSITE_PROP_MODE = 0
End Enum

Private Enum D2D1_HDRTONEMAP_PROP
    D2D1_HDRTONEMAP_PROP_INPUT_MAX_LUMINANCE = 0
    D2D1_HDRTONEMAP_PROP_OUTPUT_MAX_LUMINANCE = 1
    D2D1_HDRTONEMAP_PROP_DISPLAY_MODE = 2
End Enum

Private Enum D2D1_SATURATION_PROP
    D2D1_SATURATION_PROP_SATURATION = 0
End Enum

Private Enum D2D1_STRAIGHTEN_PROP
    D2D1_STRAIGHTEN_PROP_ANGLE = 0
    D2D1_STRAIGHTEN_PROP_MAINTAIN_SIZE = 1
    D2D1_STRAIGHTEN_PROP_SCALE_MODE = 2
End Enum

Private Enum D2D1_BRIGHTNESS_PROP
    D2D1_BRIGHTNESS_PROP_WHITE_POINT = 0
    D2D1_BRIGHTNESS_PROP_BLACK_POINT = 1
End Enum

Private Enum D2D1_MORPHOLOGY_PROP
    D2D1_MORPHOLOGY_PROP_MODE = 0
    D2D1_MORPHOLOGY_PROP_WIDTH = 1
    D2D1_MORPHOLOGY_PROP_HEIGHT = 2
End Enum

Private Enum D2D1_TURBULENCE_PROP
    D2D1_TURBULENCE_PROP_OFFSET = 0
    D2D1_TURBULENCE_PROP_SIZE = 1
    D2D1_TURBULENCE_PROP_BASE_FREQUENCY = 2
    D2D1_TURBULENCE_PROP_NUM_OCTAVES = 3
    D2D1_TURBULENCE_PROP_SEED = 4
    D2D1_TURBULENCE_PROP_NOISE = 5
    D2D1_TURBULENCE_PROP_STITCHABLE = 6
End Enum

Private Enum D2D1_HUEROTATION_PROP
    D2D1_HUEROTATION_PROP_ANGLE = 0
End Enum

Private Enum D2D1_GAUSSIANBLUR_PROP
    D2D1_GAUSSIANBLUR_PROP_STANDARD_DEVIATION = 0
    D2D1_GAUSSIANBLUR_PROP_OPTIMIZATION = 1
    D2D1_GAUSSIANBLUR_PROP_BORDER_MODE = 2
End Enum

Private Enum D2D1_BITMAPSOURCE_PROP
    D2D1_BITMAPSOURCE_PROP_WIC_BITMAP_SOURCE = 0
    D2D1_BITMAPSOURCE_PROP_SCALE = 1
    D2D1_BITMAPSOURCE_PROP_INTERPOLATION_MODE = 2
    D2D1_BITMAPSOURCE_PROP_ENABLE_DPI_CORRECTION = 3
    D2D1_BITMAPSOURCE_PROP_ALPHA_MODE = 4
    D2D1_BITMAPSOURCE_PROP_ORIENTATION = 5
End Enum

Private Enum D2D1_EDGEDETECTION_PROP
    D2D1_EDGEDETECTION_PROP_STRENGTH = 0
    D2D1_EDGEDETECTION_PROP_BLUR_RADIUS = 1
    D2D1_EDGEDETECTION_PROP_MODE = 2
    D2D1_EDGEDETECTION_PROP_OVERLAY_EDGES = 3
    D2D1_EDGEDETECTION_PROP_ALPHA_MODE = 4
End Enum

Private Enum D2D1_TABLETRANSFER_PROP
    D2D1_TABLETRANSFER_PROP_RED_TABLE = 0
    D2D1_TABLETRANSFER_PROP_RED_DISABLE = 1
    D2D1_TABLETRANSFER_PROP_GREEN_TABLE = 2
    D2D1_TABLETRANSFER_PROP_GREEN_DISABLE = 3
    D2D1_TABLETRANSFER_PROP_BLUE_TABLE = 4
    D2D1_TABLETRANSFER_PROP_BLUE_DISABLE = 5
    D2D1_TABLETRANSFER_PROP_ALPHA_TABLE = 6
    D2D1_TABLETRANSFER_PROP_ALPHA_DISABLE = 7
    D2D1_TABLETRANSFER_PROP_CLAMP_OUTPUT = 8
End Enum
        
Private Enum D2D1_GAMMATRANSFER_PROP
    D2D1_GAMMATRANSFER_PROP_RED_AMPLITUDE = 0
    D2D1_GAMMATRANSFER_PROP_RED_EXPONENT = 1
    D2D1_GAMMATRANSFER_PROP_RED_OFFSET = 2
    D2D1_GAMMATRANSFER_PROP_RED_DISABLE = 3
    D2D1_GAMMATRANSFER_PROP_GREEN_AMPLITUDE = 4
    D2D1_GAMMATRANSFER_PROP_GREEN_EXPONENT = 5
    D2D1_GAMMATRANSFER_PROP_GREEN_OFFSET = 6
    D2D1_GAMMATRANSFER_PROP_GREEN_DISABLE = 7
    D2D1_GAMMATRANSFER_PROP_BLUE_AMPLITUDE = 8
    D2D1_GAMMATRANSFER_PROP_BLUE_EXPONENT = 9
    D2D1_GAMMATRANSFER_PROP_BLUE_OFFSET = 10
    D2D1_GAMMATRANSFER_PROP_BLUE_DISABLE = 11
    D2D1_GAMMATRANSFER_PROP_ALPHA_AMPLITUDE = 12
    D2D1_GAMMATRANSFER_PROP_ALPHA_EXPONENT = 13
    D2D1_GAMMATRANSFER_PROP_ALPHA_OFFSET = 14
    D2D1_GAMMATRANSFER_PROP_ALPHA_DISABLE = 15
    D2D1_GAMMATRANSFER_PROP_CLAMP_OUTPUT = 16
End Enum

Private Enum D2D1_LINEARTRANSFER_PROP
    D2D1_LINEARTRANSFER_PROP_RED_Y_INTERCEPT = 0
    D2D1_LINEARTRANSFER_PROP_RED_SLOPE = 1
    D2D1_LINEARTRANSFER_PROP_RED_DISABLE = 2
    D2D1_LINEARTRANSFER_PROP_GREEN_Y_INTERCEPT = 3
    D2D1_LINEARTRANSFER_PROP_GREEN_SLOPE = 4
    D2D1_LINEARTRANSFER_PROP_GREEN_DISABLE = 5
    D2D1_LINEARTRANSFER_PROP_BLUE_Y_INTERCEPT = 6
    D2D1_LINEARTRANSFER_PROP_BLUE_SLOPE = 7
    D2D1_LINEARTRANSFER_PROP_BLUE_DISABLE = 8
    D2D1_LINEARTRANSFER_PROP_ALPHA_Y_INTERCEPT = 9
    D2D1_LINEARTRANSFER_PROP_ALPHA_SLOPE = 10
    D2D1_LINEARTRANSFER_PROP_ALPHA_DISABLE = 11
    D2D1_LINEARTRANSFER_PROP_CLAMP_OUTPUT = 12
End Enum

Private Enum D2D1_CONVOLVEMATRIX_PROP
    D2D1_CONVOLVEMATRIX_PROP_KERNEL_UNIT_LENGTH = 0
    D2D1_CONVOLVEMATRIX_PROP_SCALE_MODE = 1
    D2D1_CONVOLVEMATRIX_PROP_KERNEL_SIZE_X = 2
    D2D1_CONVOLVEMATRIX_PROP_KERNEL_SIZE_Y = 3
    D2D1_CONVOLVEMATRIX_PROP_KERNEL_MATRIX = 4
    D2D1_CONVOLVEMATRIX_PROP_DIVISOR = 5
    D2D1_CONVOLVEMATRIX_PROP_BIAS = 6
    D2D1_CONVOLVEMATRIX_PROP_KERNEL_OFFSET = 7
    D2D1_CONVOLVEMATRIX_PROP_PRESERVE_ALPHA = 8
    D2D1_CONVOLVEMATRIX_PROP_BORDER_MODE = 9
    D2D1_CONVOLVEMATRIX_PROP_CLAMP_OUTPUT = 10
End Enum

Private Enum D2D1_COLORMANAGEMENT_PROP
    D2D1_COLORMANAGEMENT_PROP_SOURCE_COLOR_CONTEXT = 0
    D2D1_COLORMANAGEMENT_PROP_SOURCE_RENDERING_INTENT = 1
    D2D1_COLORMANAGEMENT_PROP_DESTINATION_COLOR_CONTEXT = 2
    D2D1_COLORMANAGEMENT_PROP_DESTINATION_RENDERING_INTENT = 3
    D2D1_COLORMANAGEMENT_PROP_ALPHA_MODE = 4
    D2D1_COLORMANAGEMENT_PROP_QUALITY = 5
End Enum

Private Enum D2D1_DISTANTDIFFUSE_PROP
    D2D1_DISTANTDIFFUSE_PROP_AZIMUTH = 0
    D2D1_DISTANTDIFFUSE_PROP_ELEVATION = 1
    D2D1_DISTANTDIFFUSE_PROP_DIFFUSE_CONSTANT = 2
    D2D1_DISTANTDIFFUSE_PROP_SURFACE_SCALE = 3
    D2D1_DISTANTDIFFUSE_PROP_COLOR = 4
    D2D1_DISTANTDIFFUSE_PROP_KERNEL_UNIT_LENGTH = 5
    D2D1_DISTANTDIFFUSE_PROP_SCALE_MODE = 6
End Enum

Private Enum D2D1_DISTANTSPECULAR_PROP
    D2D1_DISTANTSPECULAR_PROP_AZIMUTH = 0
    D2D1_DISTANTSPECULAR_PROP_ELEVATION = 1
    D2D1_DISTANTSPECULAR_PROP_SPECULAR_EXPONENT = 2
    D2D1_DISTANTSPECULAR_PROP_SPECULAR_CONSTANT = 3
    D2D1_DISTANTSPECULAR_PROP_SURFACE_SCALE = 4
    D2D1_DISTANTSPECULAR_PROP_COLOR = 5
    D2D1_DISTANTSPECULAR_PROP_KERNEL_UNIT_LENGTH = 6
    D2D1_DISTANTSPECULAR_PROP_SCALE_MODE = 7
End Enum

Private Enum D2D1_POINTDIFFUSE_PROP
    D2D1_POINTDIFFUSE_PROP_LIGHT_POSITION = 0
    D2D1_POINTDIFFUSE_PROP_DIFFUSE_CONSTANT = 1
    D2D1_POINTDIFFUSE_PROP_SURFACE_SCALE = 2
    D2D1_POINTDIFFUSE_PROP_COLOR = 3
    D2D1_POINTDIFFUSE_PROP_KERNEL_UNIT_LENGTH = 4
    D2D1_POINTDIFFUSE_PROP_SCALE_MODE = 5
End Enum

Private Enum D2D1_POINTSPECULAR_PROP
    D2D1_POINTSPECULAR_PROP_LIGHT_POSITION = 0
    D2D1_POINTSPECULAR_PROP_SPECULAR_EXPONENT = 1
    D2D1_POINTSPECULAR_PROP_SPECULAR_CONSTANT = 2
    D2D1_POINTSPECULAR_PROP_SURFACE_SCALE = 3
    D2D1_POINTSPECULAR_PROP_COLOR = 4
    D2D1_POINTSPECULAR_PROP_KERNEL_UNIT_LENGTH = 5
    D2D1_POINTSPECULAR_PROP_SCALE_MODE = 6
End Enum

Private Enum D2D1_DPICOMPENSATION_PROP
    D2D1_DPICOMPENSATION_PROP_INTERPOLATION_MODE = 0
    D2D1_DPICOMPENSATION_PROP_BORDER_MODE = 1
    D2D1_DPICOMPENSATION_PROP_INPUT_DPI = 2
End Enum

Private Enum D2D1_DIRECTIONALBLUR_PROP
    D2D1_DIRECTIONALBLUR_PROP_STANDARD_DEVIATION = 0
    D2D1_DIRECTIONALBLUR_PROP_ANGLE = 1
    D2D1_DIRECTIONALBLUR_PROP_OPTIMIZATION = 2
    D2D1_DIRECTIONALBLUR_PROP_BORDER_MODE = 3
End Enum

Private Enum D2D1_TEMPERATUREANDTINT_PROP
    D2D1_TEMPERATUREANDTINT_PROP_TEMPERATURE = 0
    D2D1_TEMPERATUREANDTINT_PROP_TINT = 1
End Enum

Private Enum D2D1_DISPLACEMENTMAP_PROP
    D2D1_DISPLACEMENTMAP_PROP_SCALE = 0
    D2D1_DISPLACEMENTMAP_PROP_X_CHANNEL_SELECT = 1
    D2D1_DISPLACEMENTMAP_PROP_Y_CHANNEL_SELECT = 2
End Enum

Private Enum D2D1_DISCRETETRANSFER_PROP
    D2D1_DISCRETETRANSFER_PROP_RED_TABLE = 0
    D2D1_DISCRETETRANSFER_PROP_RED_DISABLE = 1
    D2D1_DISCRETETRANSFER_PROP_GREEN_TABLE = 2
    D2D1_DISCRETETRANSFER_PROP_GREEN_DISABLE = 3
    D2D1_DISCRETETRANSFER_PROP_BLUE_TABLE = 4
    D2D1_DISCRETETRANSFER_PROP_BLUE_DISABLE = 5
    D2D1_DISCRETETRANSFER_PROP_ALPHA_TABLE = 6
    D2D1_DISCRETETRANSFER_PROP_ALPHA_DISABLE = 7
    D2D1_DISCRETETRANSFER_PROP_CLAMP_OUTPUT = 8
End Enum

Private Enum D2D1_HIGHLIGHTSANDSHADOWS_PROP
    D2D1_HIGHLIGHTSANDSHADOWS_PROP_HIGHLIGHTS = 0
    D2D1_HIGHLIGHTSANDSHADOWS_PROP_SHADOWS = 1
    D2D1_HIGHLIGHTSANDSHADOWS_PROP_CLARITY = 2
    D2D1_HIGHLIGHTSANDSHADOWS_PROP_INPUT_GAMMA = 3
    D2D1_HIGHLIGHTSANDSHADOWS_PROP_MASK_BLUR_RADIUS = 4
End Enum
        
Private Enum D2D1_2DAFFINETRANSFORM_PROP
    D2D1_2DAFFINETRANSFORM_PROP_INTERPOLATION_MODE = 0
    D2D1_2DAFFINETRANSFORM_PROP_BORDER_MODE = 1
    D2D1_2DAFFINETRANSFORM_PROP_TRANSFORM_MATRIX = 2
    D2D1_2DAFFINETRANSFORM_PROP_SHARPNESS = 3
End Enum

Private Enum D2D1_SPOTDIFFUSE_PROP
    D2D1_SPOTDIFFUSE_PROP_LIGHT_POSITION = 0
    D2D1_SPOTDIFFUSE_PROP_POINTS_AT = 1
    D2D1_SPOTDIFFUSE_PROP_FOCUS = 2
    D2D1_SPOTDIFFUSE_PROP_LIMITING_CONE_ANGLE = 3
    D2D1_SPOTDIFFUSE_PROP_DIFFUSE_CONSTANT = 4
    D2D1_SPOTDIFFUSE_PROP_SURFACE_SCALE = 5
    D2D1_SPOTDIFFUSE_PROP_COLOR = 6
    D2D1_SPOTDIFFUSE_PROP_KERNEL_UNIT_LENGTH = 7
    D2D1_SPOTDIFFUSE_PROP_SCALE_MODE = 8
End Enum

Private Enum D2D1_SPOTSPECULAR_PROP
    D2D1_SPOTSPECULAR_PROP_LIGHT_POSITION = 0
    D2D1_SPOTSPECULAR_PROP_POINTS_AT = 1
    D2D1_SPOTSPECULAR_PROP_FOCUS = 2
    D2D1_SPOTSPECULAR_PROP_LIMITING_CONE_ANGLE = 3
    D2D1_SPOTSPECULAR_PROP_SPECULAR_EXPONENT = 4
    D2D1_SPOTSPECULAR_PROP_SPECULAR_CONSTANT = 5
    D2D1_SPOTSPECULAR_PROP_SURFACE_SCALE = 6
    D2D1_SPOTSPECULAR_PROP_COLOR = 7
    D2D1_SPOTSPECULAR_PROP_KERNEL_UNIT_LENGTH = 8
    D2D1_SPOTSPECULAR_PROP_SCALE_MODE = 9
End Enum

Private Enum D2D1_ARITHMETICCOMPOSITE_PROP
    D2D1_ARITHMETICCOMPOSITE_PROP_COEFFICIENTS = 0
    D2D1_ARITHMETICCOMPOSITE_PROP_CLAMP_OUTPUT = 1
End Enum

Private Enum D2D1_WHITELEVELADJUSTMENT_PROP
    D2D1_WHITELEVELADJUSTMENT_PROP_INPUT_WHITE_LEVEL = 0
    D2D1_WHITELEVELADJUSTMENT_PROP_OUTPUT_WHITE_LEVEL = 1
End Enum

Private Enum D2D1_OPACITYMETADATA_PROP
    D2D1_OPACITYMETADATA_PROP_INPUT_OPAQUE_RECT = 0
End Enum

Private Enum D2D1_COLORMATRIX_PROP
    D2D1_COLORMATRIX_PROP_COLOR_MATRIX = 0
    D2D1_COLORMATRIX_PROP_ALPHA_MODE = 1
    D2D1_COLORMATRIX_PROP_CLAMP_OUTPUT = 2
End Enum

Private Enum D2D1_3DTRANSFORM_PROP
    D2D1_3DTRANSFORM_PROP_INTERPOLATION_MODE = 0
    D2D1_3DTRANSFORM_PROP_BORDER_MODE = 1
    D2D1_3DTRANSFORM_PROP_TRANSFORM_MATRIX = 2
End Enum

Private Enum D2D1_3DPERSPECTIVETRANSFORM_PROP
    D2D1_3DPERSPECTIVETRANSFORM_PROP_INTERPOLATION_MODE = 0
    D2D1_3DPERSPECTIVETRANSFORM_PROP_BORDER_MODE = 1
    D2D1_3DPERSPECTIVETRANSFORM_PROP_DEPTH = 2
    D2D1_3DPERSPECTIVETRANSFORM_PROP_PERSPECTIVE_ORIGIN = 3
    D2D1_3DPERSPECTIVETRANSFORM_PROP_LOCAL_OFFSET = 4
    D2D1_3DPERSPECTIVETRANSFORM_PROP_GLOBAL_OFFSET = 5
    D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION_ORIGIN = 6
    D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION = 7
End Enum

Private Enum D2D1_LOOKUPTABLE3D_PROP
  D2D1_LOOKUPTABLE3D_PROP_LUT = 0
  D2D1_LOOKUPTABLE3D_PROP_ALPHA_MODE = 1
End Enum

Private Enum D2D1_BUFFER_PRECISION
  D2D1_BUFFER_PRECISION_UNKNOWN = 0
  D2D1_BUFFER_PRECISION_8BPC_UNORM = 1
  D2D1_BUFFER_PRECISION_8BPC_UNORM_SRGB = 2
  D2D1_BUFFER_PRECISION_16BPC_UNORM = 3
  D2D1_BUFFER_PRECISION_16BPC_FLOAT = 4
  D2D1_BUFFER_PRECISION_32BPC_FLOAT = 5
End Enum

' ----==== Type ====----
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Private Type IID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7)  As Byte
End Type

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
End Type

Private Type WICRect
    x As Long
    y As Long
    width As Long
    height As Long
End Type

Private Type D2D1_FACTORY_OPTIONS
    eDebugLevel As D2D1_DEBUG_LEVEL
End Type
    
Private Type D2D1_PIXEL_FORMAT
    eDxgiFormat As DXGI_FORMAT
    eAlphaMode As D2D1_ALPHA_MODE
End Type

Private Type D2D1_RENDER_TARGET_PROPERTIES
    eTargetType As D2D1_RENDER_TARGET_TYPE
    tPixelFormat As D2D1_PIXEL_FORMAT
    sngDpiX As Single
    sngDpiY As Single
    eTargetUsage As D2D1_RENDER_TARGET_USAGE
    eMinFeatureLevel As D2D1_FEATURE_LEVEL
End Type

Public Type D2D1_COLOR_F
    r As Single
    g As Single
    b As Single
    a As Single
End Type

Private Type D2D1_RECT_F
    left As Single
    top As Single
    right As Single
    bottom As Single
End Type

Private Type D2D1_POINT_2F
    x As Single
    y As Single
End Type

Public Type D2D1_VECTOR_2F
    x As Single
    y As Single
End Type
        
Public Type D2D1_VECTOR_3F
    x As Single
    y As Single
    z As Single
End Type

Public Type D2D1_VECTOR_4F
    x As Single
    y As Single
    z As Single
    w As Single
End Type
        
Public Type D2D1_MATRIX_3X2_F
    m_11 As Single
    m_12 As Single
    m_21 As Single
    m_22 As Single
    m_31 As Single
    m_32 As Single
End Type

Public Type D2D1_MATRIX_4X4_F
    m_00 As Single
    m_01 As Single
    m_02 As Single
    m_03 As Single
    m_10 As Single
    m_11 As Single
    m_12 As Single
    m_13 As Single
    m_20 As Single
    m_21 As Single
    m_22 As Single
    m_23 As Single
    m_30 As Single
    m_31 As Single
    m_32 As Single
    m_33 As Single
End Type

Public Type D2D1_MATRIX_5X4_F
    m_00 As Single
    m_01 As Single
    m_02 As Single
    m_03 As Single
    m_10 As Single
    m_11 As Single
    m_12 As Single
    m_13 As Single
    m_20 As Single
    m_21 As Single
    m_22 As Single
    m_23 As Single
    m_30 As Single
    m_31 As Single
    m_32 As Single
    m_33 As Single
    m_40 As Single
    m_41 As Single
    m_42 As Single
    m_43 As Single
End Type

' ----==== Kernel32.dll API-Deklarationen ====----
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal length As Long)

Private Declare Function VirtualProtect Lib "kernel32.dll" ( _
                         ByVal lpAddress As Long, _
                         ByVal dwSize As Long, _
                         ByVal flNewProtect As Long, _
                         ByRef lpflOldProtect As Long) As Long
                         
' ----==== Gdi32.dll API-Deklarationen ====----
Private Declare Function CreateDIBSection Lib "Gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByRef pbmi As BITMAPINFO, _
                         ByVal usage As Long, _
                         ByVal ppvBits As Long, _
                         ByVal hSection As Long, _
                         ByVal offset As Long) As Long
                         
Private Declare Function SetDIBits Lib "Gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByVal hBitmap As Long, _
                         ByVal nStartScan As Long, _
                         ByVal nNumScans As Long, _
                         ByVal lpBits As Long, _
                         ByRef lpBI As BITMAPINFO, _
                         ByVal wUsage As Long) As Long
        
Private Declare Function CreateCompatibleDC Lib "Gdi32.dll" ( _
                         ByVal hdc As Long) As Long
                         
Private Declare Function DeleteDC Lib "Gdi32.dll" ( _
                         ByVal hdc As Long) As Long
                         
Private Declare Function SelectObject Lib "Gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByVal hObject As Long) As Long
                         
Private Declare Function GdiAlphaBlend Lib "Gdi32.dll" ( _
                         ByVal hdcDest As Long, _
                         ByVal xoriginDest As Long, _
                         ByVal yoriginDest As Long, _
                         ByVal wDest As Long, _
                         ByVal hDest As Long, _
                         ByVal hdcSrc As Long, _
                         ByVal xoriginSrc As Long, _
                         ByVal yoriginSrc As Long, _
                         ByVal wSrc As Long, _
                         ByVal hSrc As Long, _
                         ByVal ftn As Long) As Long
                         
' ----==== Ole32 API-Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Long, _
                         ByVal prgpvarg As Long, _
                         ByRef pvargResult As Variant) As Long

Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Long, _
                         ByRef lplpvObj As Object) As Long
        
' ----==== Windowscodecs.dll Deklarationen ====----
Private Declare Function CreateWICFactory Lib "Windowscodecs.dll" _
                         Alias "WICCreateImagingFactory_Proxy" ( _
                         ByVal sdkVersion As Long, _
                         ByRef ppIWICImagingFactory As Long) As Long

Private Declare Function CreateWICBitmap Lib "Windowscodecs.dll" _
                         Alias "IWICImagingFactory_CreateBitmap_Proxy" ( _
                         ByVal pIWICImagingFactory As Long, _
                         ByVal uiWidth As Long, _
                         ByVal uiHeight As Long, _
                         ByRef pixelFormat As GUID, _
                         ByVal eOption As WICBitmapCreateCacheOption, _
                         ByRef ppIWICBitmap As Long) As Long

Private Declare Function ConvertWICBitmap Lib "Windowscodecs.dll" _
                         Alias "WICConvertBitmapSource" ( _
                         ByRef dstFormat As GUID, _
                         ByVal pISrc As Long, _
                         ByRef ppIDst As Long) As Long

Private Declare Function CreateWICDecoderFromFilename Lib "Windowscodecs.dll" _
                         Alias "IWICImagingFactory_CreateDecoderFromFilename_Proxy" ( _
                         ByVal pFactory As Long, _
                         ByVal wzFilename As Long, _
                         ByVal pguidVendor As Long, _
                         ByVal dwDesiredAccess As WICAccessOption, _
                         ByVal metadataOptions As WICDecodeOptions, _
                         ByRef ppIDecoder As Long) As Long
                         
Private Declare Function GetWICFrameCount Lib "Windowscodecs.dll" _
                         Alias "IWICBitmapDecoder_GetFrameCount_Proxy" ( _
                         ByVal pIWICDecoder As Long, _
                         ByRef pCount As Long) As Long

Private Declare Function GetWICFrame Lib "Windowscodecs.dll" _
                         Alias "IWICBitmapDecoder_GetFrame_Proxy" ( _
                         ByVal pIWICDecoder As Long, _
                         ByVal index As Long, _
                         ByRef ppIBitmapFrame As Long) As Long

Private Declare Function LockWICBitmap Lib "Windowscodecs.dll" _
                         Alias "IWICBitmap_Lock_Proxy" ( _
                         ByVal pIBitmap As Long, _
                         ByRef prcLock As WICRect, _
                         ByVal lockFlags As WICBitmapLockFlags, _
                         ByRef ppILock As Long) As Long

Private Declare Function GetWICLockDataPointer Lib "Windowscodecs.dll" _
                         Alias "IWICBitmapLock_GetDataPointer_STA_Proxy" ( _
                         ByVal pILock As Long, _
                         ByRef pcbBufferSize As Long, _
                         ByRef ppbData As Long) As Long

Private Declare Function GetWICBitmapSourceSize Lib "Windowscodecs.dll" _
                         Alias "IWICBitmapSource_GetSize_Proxy" ( _
                         ByVal pIWICBitmapSource As Long, _
                         ByRef puiWidth As Long, _
                         ByRef puiHeight As Long) As Long

Private Declare Function CreateWICBitmapFromSource Lib "Windowscodecs.dll" _
                         Alias "IWICImagingFactory_CreateBitmapFromSource_Proxy" ( _
                         ByVal pFactory As Long, _
                         ByVal pIBitmapSource As Long, _
                         ByVal eOption As WICBitmapCreateCacheOption, _
                         ByRef ppIBitmap As Long) As Long

' ----==== D2d1.dll Deklarationen ====----
Private Declare Function CreateD2D1Factory Lib "D2d1.dll" _
                         Alias "D2D1CreateFactory" ( _
                         ByVal factoryType As D2D1_FACTORY_TYPE, _
                         ByRef riid As GUID, _
                         ByRef pFactoryOptions As D2D1_FACTORY_OPTIONS, _
                         ByRef ppID2D1Factory As Long) As Long

' ----==== Variablen ====----
Private m_IPicture_VTable As Long
Private m_IPicture_Renderer As Long
Private m_IPicture_Attributes As Long

Private m_pIWICBitmap As Long
Private m_pID2D1Factory As Long
Private m_pID2D1RenderTarget As Long
Private m_pIWICImagingFactory As Long
Private m_pID2D1DeviceContext2 As Long


Public Function Initialize() As Boolean
    
    Dim bolRet As Boolean
    Dim tD2D1_FACTORY_OPTIONS As D2D1_FACTORY_OPTIONS
    Dim tD2D1_RENDER_TARGET_PROPERTIES As D2D1_RENDER_TARGET_PROPERTIES
    
    bolRet = False
    
    ' ein WIC-Factory erstellen
    If CreateWICFactory(WINCODEC_SDK_VERSION2, m_pIWICImagingFactory) = S_OK Then
    
        tD2D1_FACTORY_OPTIONS.eDebugLevel = D2D1_DEBUG_LEVEL_NONE
    
        ' ein D2D1-Factory erstellen
        If CreateD2D1Factory(D2D1_FACTORY_TYPE_SINGLE_THREADED, _
            Str2Guid(IID_ID2D1Factory), tD2D1_FACTORY_OPTIONS, _
            m_pID2D1Factory) = S_OK Then
            
            ' ein WIC-Bitmap erstellen
            If CreateWICBitmap(m_pIWICImagingFactory, 1&, 1&, _
                Str2Guid(GUID_WICPixelFormat32bppPBGRA), _
                WICBitmapCacheOnDemand, m_pIWICBitmap) = S_OK Then
                
                With tD2D1_RENDER_TARGET_PROPERTIES
                    .tPixelFormat.eDxgiFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                    .tPixelFormat.eAlphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                End With
                
                ' vom WIC-Bitmap ein D2D1-RenderTarget erstellen
                If Invoke(m_pID2D1Factory, CreateWicBitmapRenderTarget, _
                    m_pIWICBitmap, VarPtr(tD2D1_RENDER_TARGET_PROPERTIES), _
                    VarPtr(m_pID2D1RenderTarget)) = S_OK Then
                
                    ' vom D2D1-RenderTarget ein D2D1-DeviceContext erstellen
                    If Invoke(m_pID2D1RenderTarget, QueryInterface, _
                        VarPtr(Str2Guid(IID_ID2D1DeviceContext2)), _
                        VarPtr(m_pID2D1DeviceContext2)) = S_OK Then
                    
                        bolRet = True
                        
                    End If
                
                End If
            
            End If

        End If
    
    End If

    Initialize = bolRet
    
End Function

Public Sub Terminate()
    
    Call Unconvert
    If m_pID2D1DeviceContext2 <> 0& Then Call Release(m_pID2D1DeviceContext2)
    If m_pID2D1RenderTarget <> 0& Then Call Release(m_pID2D1RenderTarget)
    If m_pIWICBitmap <> 0& Then Call Release(m_pIWICBitmap)
    If m_pID2D1Factory <> 0& Then Call Release(m_pID2D1Factory)
    If m_pIWICImagingFactory <> 0& Then Call Release(m_pIWICImagingFactory)

End Sub

Public Function ImageFileToWICBitmap(ByVal fileName As String) As Long

    Dim lngFrameCount As Long
    Dim pIWICBitmap As Long
    Dim pIWICBitmapDecoder As Long
    Dim pIWICBitmapFrameDecode As Long
    
    ' ist eine Datei vorhanden
    If Len(fileName) <> 0& Then

        ' ein WIC-BitmapDecoder von der Datei erstellen
        If CreateWICDecoderFromFilename(m_pIWICImagingFactory, StrPtr(fileName), 0&, _
            GENERIC_READ, WICDecodeMetadataCacheOnDemand, pIWICBitmapDecoder) = S_OK Then
    
            ' Anzahl der Frames ermitteln
            If GetWICFrameCount(pIWICBitmapDecoder, lngFrameCount) = S_OK Then
        
                ' mindestens ein Frame vorhanden
                If lngFrameCount > 0 Then
            
                    ' erstes Frame laden
                    If GetWICFrame(pIWICBitmapDecoder, 0&, pIWICBitmapFrameDecode) = S_OK Then
                
                        ' Frame in das 32bppPBGRA Format konvertieren -> WIC-Bitmap
                        If ConvertWICBitmap(Str2Guid(GUID_WICPixelFormat32bppPBGRA), _
                            pIWICBitmapFrameDecode, pIWICBitmap) = S_OK Then
                        
                            Call CreateWICBitmapFromSource(m_pIWICImagingFactory, _
                                pIWICBitmap, WICBitmapCacheOnDemand, ImageFileToWICBitmap)
                        
                            Call Release(pIWICBitmap)
                            
                        End If
                        
                        ' WIC-BitmapFrameDecode lschen
                        Call Release(pIWICBitmapFrameDecode)
                        
                    End If
                    
                End If
                
            End If
            
            ' WIC-BitmapDecoder lschen
            Call Release(pIWICBitmapDecoder)
            
        End If
        
    End If

End Function

Public Function WICBitmapToPicture(ByVal pIWICBitmap As Long) As StdPicture

    Dim hBitmap As Long
    Dim lngWidth As Long
    Dim lngHeight As Long
    Dim lngBuffSize As Long
    Dim pData As Long
    Dim pIWICBitmapLock As Long
    Dim tWICRect As WICRect
    Dim tPICTDESC As PICTDESC
    Dim tBITMAPINFO As BITMAPINFO
    
    If pIWICBitmap <> 0& Then
    
        If GetWICBitmapSourceSize(pIWICBitmap, lngWidth, lngHeight) = S_OK Then
        
            With tWICRect
                .x = 0
                .y = 0
                .width = lngWidth
                .height = lngHeight
            End With
            
            ' LockBits
            If LockWICBitmap(pIWICBitmap, tWICRect, _
                WICBitmapLockRead, pIWICBitmapLock) = S_OK Then
                
                ' Pointer auf die Bilddaten holen
                If GetWICLockDataPointer(pIWICBitmapLock, _
                    lngBuffSize, pData) = S_OK Then
                    
                    With tBITMAPINFO
                        .bmiHeader.biSize = Len(tBITMAPINFO.bmiHeader)
                        .bmiHeader.biWidth = lngWidth
                        .bmiHeader.biHeight = -lngHeight
                        .bmiHeader.biPlanes = 1
                        .bmiHeader.biBitCount = 32
                    End With
                    
                    ' eine DIB erstellen
                    hBitmap = CreateDIBSection(0&, tBITMAPINFO, 0&, 0&, 0&, 0&)
                    
                    ' ist ein DIB vorhanden
                    If hBitmap <> 0& Then
                    
                        ' Bildaten in die DIB kopieren
                        If SetDIBits(0&, hBitmap, 0&, lngHeight, pData, _
                            tBITMAPINFO, 0&) = lngHeight Then
                            
                            With tPICTDESC
                                .cbSizeOfStruct = Len(tPICTDESC)
                                .picType = vbPicTypeBitmap
                                .hgdiObj = hBitmap
                            End With
                            
                            ' ein StdPicture vom DIB erstellen
                            Call OleCreatePictureIndirect(tPICTDESC, _
                                Str2Guid(IID_IPicture), 1&, WICBitmapToPicture)
                                
                            Call Convert(WICBitmapToPicture)
                            
                        End If
                        
                    End If
                    
                End If
                
                Call Release(pIWICBitmapLock)
                
            End If
            
        End If
        
    End If
    
End Function

Public Function ImageFileToD2D1Image(ByVal fileName As String, _
                                     ByRef scaleBitmap As D2D1_VECTOR_2F, _
                                     Optional ByVal orientation As D2D1_BITMAPSOURCE_ORIENTATION = D2D1_BITMAPSOURCE_ORIENTATION_DEFAULT, _
                                     Optional ByVal interpolationMode As D2D1_BITMAPSOURCE_INTERPOLATION_MODE = D2D1_BITMAPSOURCE_INTERPOLATION_MODE_FANT, _
                                     Optional ByVal alphaMode As D2D1_BITMAPSOURCE_ALPHA_MODE = D2D1_BITMAPSOURCE_ALPHA_MODE_PREMULTIPLIED, _
                                     Optional ByVal enableDpiCorrection As Boolean = False) As Long
    
    Dim bytData() As Byte
    Dim pIWICBitmap As Long
    Dim pID2D1Effect As Long
    
    ' ist ein Picture vorhanden
    If Len(fileName) <> 0& Then
    
        ' Begrenzung
        If scaleBitmap.x < 0.01 Then scaleBitmap.x = 0.01
        If scaleBitmap.y < 0.01 Then scaleBitmap.y = 0.01
    
        pIWICBitmap = ImageFileToWICBitmap(fileName)
        
        If pIWICBitmap <> 0& Then
                            
            ' konvertiert ein WIC-Bitmap in ein D2D1-Image
            ImageFileToD2D1Image = CreateD2D1BitmapSourceEffect(pIWICBitmap, _
                scaleBitmap, orientation, interpolationMode, alphaMode, _
                enableDpiCorrection)
                            
            Call Release(pIWICBitmap)
                            
        End If
    
    End If
    
End Function

Public Function D2D1ImageToPicture(ByVal pID2D1Image As Long, _
                                   ByRef backColor As D2D1_COLOR_F) As StdPicture

    Dim lngWidth As Long
    Dim lngHeight As Long
    Dim pIWICBitmap As Long
    Dim pID2D1RenderTarget As Long
    Dim pID2D1DeviceContext As Long
    Dim tD2D1_RECT_F As D2D1_RECT_F
    Dim tD2D1_POINT_2F As D2D1_POINT_2F
    Dim tD2D1_RENDER_TARGET_PROPERTIES As D2D1_RENDER_TARGET_PROPERTIES

    ' ist ein D2D1-Image vorhanden
    If pID2D1Image <> 0& Then

        ' Dimsionen vom D2D1-Image ermitteln
        If Invoke(m_pID2D1DeviceContext2, GetImageLocalBounds, _
            pID2D1Image, VarPtr(tD2D1_RECT_F)) = S_OK Then
            
            ' wir begrenzen hier die max. Gre
            If tD2D1_RECT_F.left < -2.147483E+09! Then tD2D1_RECT_F.left = -4096
            If tD2D1_RECT_F.top < -2.147483E+09! Then tD2D1_RECT_F.top = -4096
            If tD2D1_RECT_F.right > 2.147483E+09! Then tD2D1_RECT_F.right = 4096
            If tD2D1_RECT_F.bottom > 2.147483E+09! Then tD2D1_RECT_F.bottom = 4096
            
            ' Hhe und Breite speichern
            lngWidth = CLng(tD2D1_RECT_F.right)
            lngHeight = CLng(tD2D1_RECT_F.bottom)
            
            ' ein WIC-Bitmap in entsprechenden Dimensionen erstellen
            If CreateWICBitmap(m_pIWICImagingFactory, lngWidth, lngHeight, _
                Str2Guid(GUID_WICPixelFormat32bppPBGRA), _
                WICBitmapCacheOnDemand, pIWICBitmap) = S_OK Then
                
                With tD2D1_RENDER_TARGET_PROPERTIES
                    .tPixelFormat.eDxgiFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                    .tPixelFormat.eAlphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                End With
                
                ' vom WIC-Bitmap ein D2D1-RenderTarget erstellen
                If Invoke(m_pID2D1Factory, CreateWicBitmapRenderTarget, _
                    pIWICBitmap, VarPtr(tD2D1_RENDER_TARGET_PROPERTIES), _
                    VarPtr(pID2D1RenderTarget)) = S_OK Then
                
                    ' vom D2D1-RenderTarget ein D2D1-DeviceContext erstellen
                    If Invoke(pID2D1RenderTarget, QueryInterface, _
                        VarPtr(Str2Guid(IID_ID2D1DeviceContext2)), _
                        VarPtr(pID2D1DeviceContext)) = S_OK Then
                        
                        ' mit dem zeichnen in den D2D1-DeviceContext beginnen
                        Call Invoke(pID2D1DeviceContext, BeginDraw)
                        
                        ' Hintergrund mit einer Farbe lschen
                        Call Invoke(pID2D1DeviceContext, Clear, VarPtr(backColor))
                        
                        With tD2D1_POINT_2F
                            .x = tD2D1_RECT_F.left
                            .y = tD2D1_RECT_F.top
                        End With
                        
                        ' zeichnet das D2D1-Image in den D2D1-DeviceContext
                        Call Invoke(pID2D1DeviceContext, DrawImage, pID2D1Image, _
                            VarPtr(tD2D1_POINT_2F), VarPtr(tD2D1_RECT_F), _
                            D2D1_INTERPOLATION_MODE.D2D1_INTERPOLATION_MODE_LINEAR, _
                            D2D1_COMPOSITE_MODE.D2D1_COMPOSITE_MODE_SOURCE_OVER)
                    
                        ' zeichnen in den D2D1-DeviceContext beenden
                        Call Invoke(pID2D1DeviceContext, EndDraw, 0&, 0&)
                    
                        ' D2D1-DeviceContext lschen
                        Call Release(pID2D1DeviceContext)
                    
                    End If
                
                    ' D2D1-RenderTarget lschen
                    Call Release(pID2D1RenderTarget)
                
                End If
                
                Set D2D1ImageToPicture = WICBitmapToPicture(pIWICBitmap)
                
                ' WIC-Bitmap lschen
                Call Release(pIWICBitmap)
                
            End If
        
        End If
    
    End If

End Function

Public Function CreateD2D1TintEffect(ByVal pID2D1Image As Long, _
                                     ByRef color As D2D1_VECTOR_4F, _
                                     Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Tint)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(color)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_TINT_PROP.D2D1_TINT_PROP_COLOR, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = BooleanToByteArray(clampOutput)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_TINT_PROP.D2D1_TINT_PROP_CLAMP_OUTPUT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1TintEffect))
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1CropEffect(ByVal pID2D1Image As Long, _
                                     ByRef rect As D2D1_VECTOR_4F, _
                                     Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Crop)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(rect)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_CROP_PROP.D2D1_CROP_PROP_RECT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(borderMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_CROP_PROP.D2D1_CROP_PROP_BORDER_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1CropEffect))
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1TileEffect(ByVal pID2D1Image As Long, _
                                     ByRef rect As D2D1_VECTOR_4F) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Tile)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(rect)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_TILE_PROP.D2D1_TILE_PROP_RECT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1TileEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1YCbCrEffect(ByVal pID2D1Image0 As Long, _
                                      ByVal pID2D1Image1 As Long, _
                                      ByRef matrix As D2D1_MATRIX_3X2_F, _
                                      Optional ByVal chromaSubsampling As D2D1_YCBCR_CHROMA_SUBSAMPLING = D2D1_YCBCR_CHROMA_SUBSAMPLING_AUTO, _
                                      Optional ByVal interpolationMode As D2D1_YCBCR_INTERPOLATION_MODE = D2D1_YCBCR_INTERPOLATION_MODE_LINEAR) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 And pID2D1Image1 <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1YCbCr)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
            Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
            
            bytData = LongToByteArray(chromaSubsampling)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_YCBCR_PROP.D2D1_YCBCR_PROP_CHROMA_SUBSAMPLING, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Matrix_3X2ToByteArray(matrix)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_YCBCR_PROP.D2D1_YCBCR_PROP_TRANSFORM_MATRIX, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_MATRIX_3X2, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(interpolationMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_YCBCR_PROP.D2D1_YCBCR_PROP_INTERPOLATION_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1YCbCrEffect))
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1AtlasEffect(ByVal pID2D1Image As Long, _
                                      ByRef inputRect As D2D1_VECTOR_4F, _
                                      ByRef paddingRect As D2D1_VECTOR_4F) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Atlas)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(inputRect)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_ATLAS_PROP.D2D1_ATLAS_PROP_INPUT_RECT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector4ToByteArray(paddingRect)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_ATLAS_PROP.D2D1_ATLAS_PROP_INPUT_PADDING_RECT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1AtlasEffect))
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1BlendEffect(ByVal pID2D1Image0 As Long, _
                                      ByVal pID2D1Image1 As Long, _
                                      Optional ByVal blendMode As D2D1_BLEND_MODE = D2D1_BLEND_MODE_MULTIPLY) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 Then
        If pID2D1Image1 <> 0 Then
    
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1Blend)), _
                VarPtr(pID2D1Effect)) = S_OK Then
            
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
                Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
            
                bytData = LongToByteArray(blendMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_BLEND_PROP.D2D1_BLEND_PROP_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1BlendEffect))
                        
                End If
            
                Call Release(pID2D1Effect)
            
            End If
            
        End If
    
    End If

End Function

Public Function CreateD2D1FloodEffect(ByRef color As D2D1_VECTOR_4F) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
        VarPtr(Str2Guid(CLSID_D2D1Flood)), _
        VarPtr(pID2D1Effect)) = S_OK Then
            
        bytData = Vector4ToByteArray(color)
        If Invoke(pID2D1Effect, SetValue, _
            D2D1_FLOOD_PROP.D2D1_FLOOD_PROP_COLOR, _
            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1FloodEffect))
                        
        End If
            
        Call Release(pID2D1Effect)
            
    End If
    
End Function

Public Function CreateD2D1SepiaEffect(ByVal pID2D1Image As Long, _
                                      Optional ByVal intensity As Single = 0.5, _
                                      Optional ByVal alphaMode = D2D1_ALPHA_MODE.D2D1_ALPHA_MODE_PREMULTIPLIED) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        intensity = ClampSingle(intensity, 0, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Sepia)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(intensity)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SEPIA_PROP.D2D1_SEPIA_PROP_INTENSITY, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(alphaMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SEPIA_PROP.D2D1_SEPIA_PROP_ALPHA_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1SepiaEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1ScaleEffect(ByVal pID2D1Image As Long, _
                                      ByRef scaleBitmap As D2D1_VECTOR_2F, _
                                      ByRef centerPoint As D2D1_VECTOR_2F, _
                                      Optional ByVal sharpness As Single = 0, _
                                      Optional ByVal interpolationMode As D2D1_SCALE_INTERPOLATION_MODE = D2D1_SCALE_INTERPOLATION_MODE_LINEAR, _
                                      Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        sharpness = ClampSingle(sharpness, 0, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Scale)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector2ToByteArray(scaleBitmap)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SCALE_PROP.D2D1_SCALE_PROP_SCALE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector2ToByteArray(centerPoint)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SCALE_PROP.D2D1_SCALE_PROP_CENTER_POINT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = LongToByteArray(interpolationMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_SCALE_PROP.D2D1_SCALE_PROP_INTERPOLATION_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = LongToByteArray(borderMode)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_SCALE_PROP.D2D1_SCALE_PROP_BORDER_MODE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                            bytData = SingleToByteArray(sharpness)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_SCALE_PROP.D2D1_SCALE_PROP_SHARPNESS, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ScaleEffect))
                            
                            End If
                        
                        End If
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1ShadowEffect(ByVal pID2D1Image As Long, _
                                       ByRef color As D2D1_VECTOR_4F, _
                                       Optional ByVal standardDeviation As Single = 3, _
                                       Optional ByVal optimation As D2D1_SHADOW_OPTIMIZATION = D2D1_SHADOW_OPTIMIZATION_BALANCED) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If standardDeviation < 0 Then standardDeviation = 0
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Shadow)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(standardDeviation)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SHADOW_PROP.D2D1_SHADOW_PROP_BLUR_STANDARD_DEVIATION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector4ToByteArray(color)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SHADOW_PROP.D2D1_SHADOW_PROP_COLOR, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = LongToByteArray(optimation)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_SHADOW_PROP.D2D1_SHADOW_PROP_OPTIMIZATION, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ShadowEffect))
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1BorderEffect(ByVal pID2D1Image As Long, _
                                       Optional ByVal edgeModeX As D2D1_BORDER_EDGE_MODE = D2D1_BORDER_EDGE_MODE_CLAMP, _
                                       Optional ByVal edgeModeY As D2D1_BORDER_EDGE_MODE = D2D1_BORDER_EDGE_MODE_CLAMP) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Border)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(edgeModeX)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_BORDER_PROP.D2D1_BORDER_PROP_EDGE_MODE_X, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(edgeModeY)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_BORDER_PROP.D2D1_BORDER_PROP_EDGE_MODE_Y, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1BorderEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1EmbossEffect(ByVal pID2D1Image As Long, _
                                       Optional ByVal height As Single = 1, _
                                       Optional ByVal direction As Single = 0) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        height = ClampSingle(height, 0, 10)
        direction = ClampSingle(direction, 0, 360)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Emboss)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(height)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_EMBOSS_PROP.D2D1_EMBOSS_PROP_HEIGHT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(direction)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_EMBOSS_PROP.D2D1_EMBOSS_PROP_DIRECTION, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1EmbossEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1InvertEffect(ByVal pID2D1Image As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Invert)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
                        
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1InvertEffect))
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1SharpenEffect(ByVal pID2D1Image As Long, _
                                        Optional ByVal sharpness As Single = 1, _
                                        Optional ByVal threshold As Single = 0) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
        
        sharpness = ClampSingle(sharpness, 0, 10)
        threshold = ClampSingle(threshold, 0, 1)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Sharpen)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(sharpness)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SHARPEN_PROP.D2D1_SHARPEN_PROP_SHARPNESS, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(threshold)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SHARPEN_PROP.D2D1_SHARPEN_PROP_THRESHOLD, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1SharpenEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1OpacityEffect(ByVal pID2D1Image As Long, _
                                        Optional ByVal opacity As Single = 1) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        opacity = ClampSingle(opacity, 0, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Opacity)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(opacity)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_OPACITY_PROP.D2D1_OPACITY_PROP_OPACITY, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1OpacityEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1ExposureEffect(ByVal pID2D1Image As Long, _
                                         Optional ByVal exposureValue As Single = 0) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        exposureValue = ClampSingle(exposureValue, -2, 2)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Exposure)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(exposureValue)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_EXPOSURE_PROP.D2D1_EXPOSURE_PROP_EXPOSURE_VALUE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ExposureEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1VignetteEffect(ByVal pID2D1Image As Long, _
                                         ByRef color As D2D1_VECTOR_4F, _
                                         Optional ByVal transitionSize As Single = 0.1, _
                                         Optional ByVal strength As Single = 0.5) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        strength = ClampSingle(strength, 0, 1)
        transitionSize = ClampSingle(transitionSize, 0, 1)
                
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Vignette)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(color)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_VIGNETTE_PROP.D2D1_VIGNETTE_PROP_COLOR, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(transitionSize)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_VIGNETTE_PROP.D2D1_VIGNETTE_PROP_TRANSITION_SIZE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = SingleToByteArray(strength)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_VIGNETTE_PROP.D2D1_VIGNETTE_PROP_STRENGTH, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1VignetteEffect))
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1ContrastEffect(ByVal pID2D1Image As Long, _
                                         Optional ByVal contrast As Single = 0, _
                                         Optional ByVal clampInput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        contrast = ClampSingle(contrast, -1, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Contrast)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(contrast)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_CONTRAST_PROP.D2D1_CONTRAST_PROP_CONTRAST, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = BooleanToByteArray(clampInput)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_CONTRAST_PROP.D2D1_CONTRAST_PROP_CLAMP_INPUT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ContrastEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1RgbToHueEffect(ByVal pID2D1Image As Long, _
                                         Optional ByVal colorSpace As D2D1_RGBTOHUE_OUTPUT_COLOR_SPACE = D2D1_RGBTOHUE_OUTPUT_COLOR_SPACE_HUE_SATURATION_VALUE) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1RgbToHue)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(colorSpace)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_RGBTOHUE_PROP.D2D1_RGBTOHUE_PROP_OUTPUT_COLOR_SPACE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1RgbToHueEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1HueToRgbEffect(ByVal pID2D1Image As Long, _
                                         Optional ByVal colorSpace As D2D1_HUETORGB_INPUT_COLOR_SPACE = D2D1_HUETORGB_INPUT_COLOR_SPACE_HUE_SATURATION_VALUE) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1HueToRgb)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(colorSpace)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_HUETORGB_PROP.D2D1_HUETORGB_PROP_INPUT_COLOR_SPACE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1HueToRgbEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1CrossFadeEffect(ByVal pID2D1Image0 As Long, _
                                          ByVal pID2D1Image1 As Long, _
                                          Optional ByVal weight As Single = 0.5) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 Then
        If pID2D1Image1 <> 0 Then
            
            weight = ClampSingle(weight, 0, 1)
    
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1CrossFade)), _
                VarPtr(pID2D1Effect)) = S_OK Then
            
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
                Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
            
                bytData = SingleToByteArray(weight)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_CROSSFADE_PROP.D2D1_CROSSFADE_PROP_WEIGHT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1CrossFadeEffect))
                        
                End If
            
                Call Release(pID2D1Effect)
            
            End If
            
        End If
    
    End If

End Function

Public Function CreateD2D1AlphaMaskEffect(ByVal pID2D1Image0 As Long, _
                                          ByVal pID2D1Image1 As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 Then
        If pID2D1Image1 <> 0 Then
    
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1AlphaMask)), _
                VarPtr(pID2D1Effect)) = S_OK Then
            
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
                Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
            
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1AlphaMaskEffect))
                        
                Call Release(pID2D1Effect)
            
            End If
            
        End If
    
    End If

End Function

Public Function CreateD2D1PosterizeEffect(ByVal pID2D1Image As Long, _
                                          Optional ByVal redCount As Long = 4, _
                                          Optional ByVal greenCount As Long = 4, _
                                          Optional ByVal blueCount As Long = 4) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        redCount = ClampLong(redCount, 2, 16)
        greenCount = ClampLong(greenCount, 2, 16)
        blueCount = ClampLong(blueCount, 2, 16)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Posterize)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(redCount)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_POSTERIZE_PROP.D2D1_POSTERIZE_PROP_RED_VALUE_COUNT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(greenCount)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_POSTERIZE_PROP.D2D1_POSTERIZE_PROP_GREEN_VALUE_COUNT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(blueCount)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_POSTERIZE_PROP.D2D1_POSTERIZE_PROP_BLUE_VALUE_COUNT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1PosterizeEffect))
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1GrayscaleEffect(ByVal pID2D1Image As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Grayscale)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
                        
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1GrayscaleEffect))
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1ChromaKeyEffect(ByVal pID2D1Image As Long, _
                                          ByRef color As D2D1_VECTOR_3F, _
                                          Optional ByVal tolerance As Single = 0.1, _
                                          Optional ByVal invertAlpha As Boolean = False, _
                                          Optional ByVal feather As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        tolerance = ClampSingle(tolerance, 0, 1)
        
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1ChromaKey)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector3ToByteArray(color)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_CHROMAKEY_PROP.D2D1_CHROMAKEY_PROP_COLOR, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(tolerance)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_CHROMAKEY_PROP.D2D1_CHROMAKEY_PROP_TOLERANCE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = BooleanToByteArray(invertAlpha)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_CHROMAKEY_PROP.D2D1_CHROMAKEY_PROP_INVERT_ALPHA, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = BooleanToByteArray(feather)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_CHROMAKEY_PROP.D2D1_CHROMAKEY_PROP_FEATHER, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ChromaKeyEffect))
                        
                        End If
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1CompositeEffect(ByVal pID2D1Images As Variant, _
                                          Optional ByVal compositeMode As D2D1_COMPOSITE_MODE = D2D1_COMPOSITE_MODE_SOURCE_OVER) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim lngInputNr As Long
    
    lngCount = UBound(pID2D1Images)

    ' mindestens 2 Eintrge im Array
    If lngCount >= 1& Then

        ' die ersten beiden Eintrge im Array mssen ein ID2D1Image enthalten
        If VarType(pID2D1Images(0)) = vbLong And pID2D1Images(0) <> 0& Then
            If VarType(pID2D1Images(1)) = vbLong And pID2D1Images(1) <> 0& Then
    
                If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                    VarPtr(Str2Guid(CLSID_D2D1Composite)), _
                    VarPtr(pID2D1Effect)) = S_OK Then
                    
                    lngInputNr = 0
                    For lngItem = 0 To lngCount
                    
                        If VarType(pID2D1Images(lngItem)) = vbLong And pID2D1Images(lngItem) <> 0& Then
                        
                            Call Invoke(pID2D1Effect, SetInput, lngInputNr, pID2D1Images(lngItem), 1&)
                            
                            lngInputNr = lngInputNr + 1
                            
                        End If
                    
                    Next
            
                    bytData = LongToByteArray(compositeMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_COMPOSITE_PROP.D2D1_COMPOSITE_PROP_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1CompositeEffect))
                        
                    End If
            
                    Call Release(pID2D1Effect)
            
                End If
            
            End If
    
        End If
    
    End If

End Function

Public Function CreateD2D1HistogramEffect(pID2D1Image As Long, _
                                          ByRef lngHistogramDataSize As Long, _
                                          ByRef sngHistogramData() As Single, _
                                          Optional channelSelector As D2D1_CHANNEL_SELECTOR = D2D1_CHANNEL_SELECTOR_A) As Boolean
    Dim bolRet As Boolean
    Dim lngItem As Long
    Dim bytData() As Byte
    Dim pHistogram As Long
    Dim pID2D1Effect As Long
    
    bolRet = False
    
    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Histogram)), _
            VarPtr(pID2D1Effect)) = S_OK Then
                
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
                
            bytData = LongToByteArray(channelSelector)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_HISTOGRAM_PROP.D2D1_HISTOGRAM_PROP_CHANNEL_SELECT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(pHistogram))
                    
                Call Invoke(m_pID2D1DeviceContext2, BeginDraw)

                Call Invoke(m_pID2D1DeviceContext2, DrawImage, pHistogram, _
                    VarPtr(NewPoint_2F), VarPtr(NewRect_F), _
                    D2D1_INTERPOLATION_MODE.D2D1_INTERPOLATION_MODE_LINEAR, _
                    D2D1_COMPOSITE_MODE.D2D1_COMPOSITE_MODE_SOURCE_OVER)
                    
                Call Invoke(m_pID2D1DeviceContext2, EndDraw, 0&, 0&)
                    
                bytData = LongToByteArray(lngHistogramDataSize)
                If Invoke(pID2D1Effect, GetValue, _
                    D2D1_HISTOGRAM_PROP.D2D1_HISTOGRAM_PROP_NUM_BINS, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then

                    Call CopyMemory(lngHistogramDataSize, bytData(0), LenB(lngHistogramDataSize))
                        
                    ReDim sngHistogramData(lngHistogramDataSize - 1)
                    bytData = SingleArrayToByteArray(sngHistogramData)
                    If Invoke(pID2D1Effect, GetValue, _
                        D2D1_HISTOGRAM_PROP.D2D1_HISTOGRAM_PROP_HISTOGRAM_OUTPUT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                        Call CopyMemory(sngHistogramData(0), bytData(0), lngHistogramDataSize * LenB(sngHistogramData(0)))

                        bolRet = True

                    End If
                        
                End If
                    
                Call Release(pHistogram)
                    
            End If
                
            Call Release(pID2D1Effect)
                
        End If
            
    End If
                                          
    CreateD2D1HistogramEffect = bolRet
    
End Function

Public Function CreateD2D1HdrToneMapEffect(ByVal pID2D1Image As Long, _
                                           Optional ByVal inputMaxLuminance As Single = 100, _
                                           Optional ByVal outputMaxLuminance As Single = 100, _
                                           Optional ByVal displayMode As D2D1_HDRTONEMAP_DISPLAY_MODE = D2D1_HDRTONEMAP_DISPLAY_MODE_HDR) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If inputMaxLuminance < 2 Then inputMaxLuminance = 2
        If outputMaxLuminance < 2 Then outputMaxLuminance = 2
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1HdrToneMap)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(inputMaxLuminance)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_HDRTONEMAP_PROP.D2D1_HDRTONEMAP_PROP_INPUT_MAX_LUMINANCE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(outputMaxLuminance)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_HDRTONEMAP_PROP.D2D1_HDRTONEMAP_PROP_OUTPUT_MAX_LUMINANCE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = LongToByteArray(displayMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_HDRTONEMAP_PROP.D2D1_HDRTONEMAP_PROP_DISPLAY_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1HdrToneMapEffect))
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1SaturationEffect(ByVal pID2D1Image As Long, _
                                           Optional ByVal saturation As Single = 1) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        saturation = ClampSingle(saturation, 0, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Saturation)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(saturation)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SATURATION_PROP.D2D1_SATURATION_PROP_SATURATION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1SaturationEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1StraightenEffect(ByVal pID2D1Image As Long, _
                                           Optional ByVal angle As Single = 0, _
                                           Optional ByVal maintainSize As Boolean = False, _
                                           Optional ByVal scaleMode As D2D1_STRAIGHTEN_SCALE_MODE = D2D1_STRAIGHTEN_SCALE_MODE_LINEAR) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        angle = ClampSingle(angle, -45, 45)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Straighten)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(angle)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_STRAIGHTEN_PROP.D2D1_STRAIGHTEN_PROP_ANGLE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = BooleanToByteArray(maintainSize)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_STRAIGHTEN_PROP.D2D1_STRAIGHTEN_PROP_MAINTAIN_SIZE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(scaleMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_STRAIGHTEN_PROP.D2D1_STRAIGHTEN_PROP_SCALE_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1StraightenEffect))
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1BrightnessEffect(ByVal pID2D1Image As Long, _
                                           ByRef blackPoint As D2D1_VECTOR_2F, _
                                           ByRef whitePoint As D2D1_VECTOR_2F) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        With whitePoint
            .x = ClampSingle(whitePoint.x, 0, 1)
            .y = ClampSingle(whitePoint.y, 0, 1)
        End With

        With blackPoint
            .x = ClampSingle(blackPoint.x, 0, 1)
            .y = ClampSingle(blackPoint.y, 0, 1)
        End With
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Brightness)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector2ToByteArray(whitePoint)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_BRIGHTNESS_PROP.D2D1_BRIGHTNESS_PROP_WHITE_POINT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector2ToByteArray(blackPoint)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_BRIGHTNESS_PROP.D2D1_BRIGHTNESS_PROP_BLACK_POINT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1BrightnessEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1MorphologyEffect(ByVal pID2D1Image As Long, _
                                           Optional ByVal width As Long = 1, _
                                           Optional ByVal height As Long = 1, _
                                           Optional ByVal morphologyMode As D2D1_MORPHOLOGY_MODE = D2D1_MORPHOLOGY_MODE_ERODE) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        width = ClampLong(width, 1, 100)
        height = ClampLong(height, 1, 100)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Morphology)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(morphologyMode)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_MORPHOLOGY_PROP.D2D1_MORPHOLOGY_PROP_MODE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(height)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_MORPHOLOGY_PROP.D2D1_MORPHOLOGY_PROP_HEIGHT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(width)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_MORPHOLOGY_PROP.D2D1_MORPHOLOGY_PROP_WIDTH, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1MorphologyEffect))
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1TurbulenceEffect(ByRef size As D2D1_VECTOR_2F, _
                                           ByRef baseFrequency As D2D1_VECTOR_2F, _
                                           ByRef offset As D2D1_VECTOR_2F, _
                                           Optional ByVal noise As D2D1_TURBULENCE_NOISE = D2D1_TURBULENCE_NOISE_FRACTAL_SUM, _
                                           Optional ByVal numOctaves As Long = 1, _
                                           Optional ByVal seed As Long = 0, _
                                           Optional ByVal stitchable As Boolean = False) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If numOctaves < 1 Then numOctaves = 1
    
    If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
        VarPtr(Str2Guid(CLSID_D2D1Turbulence)), _
        VarPtr(pID2D1Effect)) = S_OK Then
        
        bytData = Vector2ToByteArray(offset)
        If Invoke(pID2D1Effect, SetValue, _
            D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_OFFSET, _
            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, VarPtr(bytData(0)), _
            UBound(bytData) + 1) = S_OK Then
            
            bytData = Vector2ToByteArray(size)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_SIZE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, VarPtr(bytData( _
                0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector2ToByteArray(baseFrequency)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_BASE_FREQUENCY, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, VarPtr( _
                    bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = LongToByteArray(numOctaves)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_NUM_OCTAVES, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, VarPtr( _
                        bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = LongToByteArray(seed)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_SEED, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_INT32, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = LongToByteArray(noise)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_NOISE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = BooleanToByteArray(stitchable)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_TURBULENCE_PROP.D2D1_TURBULENCE_PROP_STITCHABLE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1TurbulenceEffect))
                                        
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
        End If
        
        Call Release(pID2D1Effect)
        
    End If
    
End Function

Public Function CreateD2D1PremultiplyEffect(ByVal pID2D1Image As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1Premultiply)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1PremultiplyEffect))
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1HueRotationEffect(ByVal pID2D1Image As Long, _
                                            Optional ByVal angle As Single = 0) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        angle = ClampSingle(angle, 0, 360)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1HueRotation)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(angle)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_HUEROTATION_PROP.D2D1_HUEROTATION_PROP_ANGLE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1HueRotationEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1SpotDiffuseEffect(ByVal pID2D1Image As Long, _
                                            ByRef color As D2D1_VECTOR_3F, _
                                            ByRef lightPosition As D2D1_VECTOR_3F, _
                                            ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                            ByRef pointsAt As D2D1_VECTOR_3F, _
                                            Optional ByVal focus As Single = 1, _
                                            Optional ByVal limitingConeAngle As Single = 90, _
                                            Optional ByVal diffuseConstant As Single = 1, _
                                            Optional ByVal surfaceScale As Single = 1, _
                                            Optional ByVal scaleMode As D2D1_SPOTDIFFUSE_SCALE_MODE = D2D1_SPOTDIFFUSE_SCALE_MODE_LINEAR) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        focus = ClampSingle(focus, 0, 200)
        limitingConeAngle = ClampSingle(limitingConeAngle, 0, 90)
        diffuseConstant = ClampSingle(diffuseConstant, 0, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1SpotDiffuse)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector3ToByteArray(lightPosition)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_LIGHT_POSITION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector3ToByteArray(pointsAt)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_POINTS_AT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(focus)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_FOCUS, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = SingleToByteArray(limitingConeAngle)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_LIMITING_CONE_ANGLE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = SingleToByteArray(diffuseConstant)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_DIFFUSE_CONSTANT, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = SingleToByteArray(surfaceScale)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_SURFACE_SCALE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = Vector3ToByteArray(color)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_COLOR, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        bytData = Vector2ToByteArray(kernelUnitLength)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_KERNEL_UNIT_LENGTH, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                            bytData = LongToByteArray(scaleMode)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_SPOTDIFFUSE_PROP.D2D1_SPOTDIFFUSE_PROP_SCALE_MODE, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1SpotDiffuseEffect))
                                            
                                            End If
                                            
                                        End If
                                            
                                    End If
                                    
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1ColorMatrixEffect(ByVal pID2D1Image As Long, _
                                            ByRef matrix As D2D1_MATRIX_5X4_F, _
                                            Optional ByVal alphaMode As D2D1_COLORMATRIX_ALPHA_MODE = D2D1_COLORMATRIX_ALPHA_MODE_PREMULTIPLIED, _
                                            Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1ColorMatrix)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Matrix_5X4ToByteArray(matrix)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_COLORMATRIX_PROP.D2D1_COLORMATRIX_PROP_COLOR_MATRIX, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_MATRIX_5X4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(alphaMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_COLORMATRIX_PROP.D2D1_COLORMATRIX_PROP_ALPHA_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = BooleanToByteArray(clampOutput)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_COLORMATRIX_PROP.D2D1_COLORMATRIX_PROP_CLAMP_OUTPUT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ColorMatrixEffect))
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D13DTransformEffect(ByVal pID2D1Image As Long, _
                                            ByRef matrix As D2D1_MATRIX_4X4_F, _
                                            Optional ByVal interpolationMode As D2D1_3DTRANSFORM_INTERPOLATION_MODE = D2D1_3DTRANSFORM_INTERPOLATION_MODE_LINEAR, _
                                            Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D13DTransform)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(interpolationMode)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_3DTRANSFORM_PROP.D2D1_3DTRANSFORM_PROP_INTERPOLATION_MODE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(borderMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_3DTRANSFORM_PROP.D2D1_3DTRANSFORM_PROP_BORDER_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = Matrix_4X4ToByteArray(matrix)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_3DTRANSFORM_PROP.D2D1_3DTRANSFORM_PROP_TRANSFORM_MATRIX, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_MATRIX_4X4, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D13DTransformEffect))
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1GaussianBlurEffect(ByVal pID2D1Image As Long, _
                                             Optional ByVal standardDeviation As Single = 3, _
                                             Optional ByVal optimation As D2D1_GAUSSIANBLUR_OPTIMIZATION = D2D1_GAUSSIANBLUR_OPTIMIZATION_BALANCED, _
                                             Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0& Then
    
        If standardDeviation < 0 Then standardDeviation = 0
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1GaussianBlur)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(standardDeviation)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_GAUSSIANBLUR_PROP.D2D1_GAUSSIANBLUR_PROP_STANDARD_DEVIATION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(optimation)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_GAUSSIANBLUR_PROP.D2D1_GAUSSIANBLUR_PROP_OPTIMIZATION, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = LongToByteArray(borderMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_GAUSSIANBLUR_PROP.D2D1_GAUSSIANBLUR_PROP_BORDER_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1GaussianBlurEffect))
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1BitmapSourceEffect(ByVal pIWICBitmap As Long, _
                                             ByRef scaleBitmap As D2D1_VECTOR_2F, _
                                             Optional ByVal orientation As D2D1_BITMAPSOURCE_ORIENTATION = D2D1_BITMAPSOURCE_ORIENTATION_DEFAULT, _
                                             Optional ByVal interpolationMode As D2D1_BITMAPSOURCE_INTERPOLATION_MODE = D2D1_BITMAPSOURCE_INTERPOLATION_MODE_FANT, _
                                             Optional ByVal alphaMode As D2D1_BITMAPSOURCE_ALPHA_MODE = D2D1_BITMAPSOURCE_ALPHA_MODE_PREMULTIPLIED, _
                                             Optional ByVal enableDpiCorrection As Boolean = False) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pIWICBitmap <> 0& Then
    
        If scaleBitmap.x < 0.01 Then scaleBitmap.x = 0.01
        If scaleBitmap.y < 0.01 Then scaleBitmap.y = 0.01
        
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1BitmapSource)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            bytData = LongToByteArray(pIWICBitmap)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_WIC_BITMAP_SOURCE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_IUNKNOWN, VarPtr( _
                bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector2ToByteArray(scaleBitmap)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_SCALE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, VarPtr( _
                    bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = LongToByteArray(interpolationMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_INTERPOLATION_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, VarPtr( _
                        bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = BooleanToByteArray(enableDpiCorrection)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_ENABLE_DPI_CORRECTION, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = LongToByteArray(alphaMode)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_ALPHA_MODE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = LongToByteArray(orientation)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_BITMAPSOURCE_PROP.D2D1_BITMAPSOURCE_PROP_ORIENTATION, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1BitmapSourceEffect))
                                        
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1PointDiffuseEffect(ByVal pID2D1Image As Long, _
                                             ByRef color As D2D1_VECTOR_3F, _
                                             ByRef lightPosition As D2D1_VECTOR_3F, _
                                             ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                             Optional ByVal diffuseConstant As Single = 1, _
                                             Optional ByVal surfaceScale As Single = 1, _
                                             Optional ByVal scaleMode As D2D1_POINTDIFFUSE_SCALE_MODE = D2D1_POINTDIFFUSE_SCALE_MODE_LINEAR) As Long
                                             
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        diffuseConstant = ClampSingle(diffuseConstant, 0, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1PointDiffuse)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector3ToByteArray(lightPosition)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_LIGHT_POSITION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(diffuseConstant)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_DIFFUSE_CONSTANT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(surfaceScale)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_SURFACE_SCALE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = Vector3ToByteArray(color)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_COLOR, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = Vector2ToByteArray(kernelUnitLength)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_KERNEL_UNIT_LENGTH, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = LongToByteArray(scaleMode)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_POINTDIFFUSE_PROP.D2D1_POINTDIFFUSE_PROP_SCALE_MODE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                        
                                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1PointDiffuseEffect))
                                            
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1SpotSpecularEffect(ByVal pID2D1Image As Long, _
                                             ByRef color As D2D1_VECTOR_3F, _
                                             ByRef lightPosition As D2D1_VECTOR_3F, _
                                             ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                             ByRef pointsAt As D2D1_VECTOR_3F, _
                                             Optional ByVal focus As Single = 1, _
                                             Optional ByVal limitingConeAngle As Single = 90, _
                                             Optional ByVal specularExponent As Single = 1, _
                                             Optional ByVal specularConstant As Single = 1, _
                                             Optional ByVal surfaceScale As Single = 1, _
                                             Optional ByVal scaleMode As D2D1_SPOTSPECULAR_SCALE_MODE = D2D1_SPOTSPECULAR_SCALE_MODE_LINEAR) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        focus = ClampSingle(focus, 0, 200)
        limitingConeAngle = ClampSingle(limitingConeAngle, 0, 90)
        specularExponent = ClampSingle(specularExponent, 1, 128)
        specularConstant = ClampSingle(specularConstant, 0, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1SpotSpecular)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector3ToByteArray(lightPosition)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_LIGHT_POSITION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = Vector3ToByteArray(pointsAt)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_POINTS_AT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(focus)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_FOCUS, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = SingleToByteArray(limitingConeAngle)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_LIMITING_CONE_ANGLE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = SingleToByteArray(specularExponent)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_SPECULAR_EXPONENT, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                                bytData = SingleToByteArray(specularConstant)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_SPECULAR_CONSTANT, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = SingleToByteArray(surfaceScale)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_SURFACE_SCALE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        bytData = Vector3ToByteArray(color)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_COLOR, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                            
                                            bytData = Vector2ToByteArray(kernelUnitLength)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_KERNEL_UNIT_LENGTH, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                            
                                                bytData = LongToByteArray(scaleMode)
                                                If Invoke(pID2D1Effect, SetValue, _
                                                    D2D1_SPOTSPECULAR_PROP.D2D1_SPOTSPECULAR_PROP_SCALE_MODE, _
                                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                            
                                                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1SpotSpecularEffect))
                                                    
                                                End If
                                            
                                            End If
                                            
                                        End If
                                            
                                    End If
                                    
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1EdgeDetectionEffect(ByVal pID2D1Image As Long, _
                                              Optional ByVal stength As Single = 0.5, _
                                              Optional ByVal blurRadius As Single = 0, _
                                              Optional ByVal edgedetectionMode As D2D1_EDGEDETECTION_MODE = D2D1_EDGEDETECTION_MODE_SOBEL, _
                                              Optional ByVal overlayEdges As Boolean = False, _
                                              Optional ByVal alphaMode As D2D1_ALPHA_MODE = D2D1_ALPHA_MODE_PREMULTIPLIED) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        stength = ClampSingle(stength, 0, 1)
        blurRadius = ClampSingle(blurRadius, 0, 10)
        
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1EdgeDetection)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(stength)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_EDGEDETECTION_PROP.D2D1_EDGEDETECTION_PROP_STRENGTH, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(blurRadius)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_EDGEDETECTION_PROP.D2D1_EDGEDETECTION_PROP_BLUR_RADIUS, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(edgedetectionMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_EDGEDETECTION_PROP.D2D1_EDGEDETECTION_PROP_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = BooleanToByteArray(overlayEdges)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_EDGEDETECTION_PROP.D2D1_EDGEDETECTION_PROP_OVERLAY_EDGES, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            bytData = LongToByteArray(alphaMode)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_EDGEDETECTION_PROP.D2D1_EDGEDETECTION_PROP_ALPHA_MODE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1EdgeDetectionEffect))
                        
                            End If
                        
                        End If
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1TableTransferEffect(ByVal pID2D1Image As Long, _
                                              ByRef redTable() As Single, _
                                              ByRef greenTable() As Single, _
                                              ByRef blueTable() As Single, _
                                              ByRef alphaTable() As Single, _
                                              Optional ByVal redDisable As Boolean = False, _
                                              Optional ByVal greenDisable As Boolean = False, _
                                              Optional ByVal blueDisable As Boolean = False, _
                                              Optional ByVal alphaDisable As Boolean = False, _
                                              Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1TableTransfer)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleArrayToByteArray(SingleArrayMin2(redTable, True, 0, 1))
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_RED_TABLE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = BooleanToByteArray(redDisable)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_RED_DISABLE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                    bytData = SingleArrayToByteArray(SingleArrayMin2(greenTable, True, 0, 1))
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_GREEN_TABLE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = BooleanToByteArray(greenDisable)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_GREEN_DISABLE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                            bytData = SingleArrayToByteArray(SingleArrayMin2(blueTable, True, 0, 1))
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_BLUE_TABLE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                bytData = BooleanToByteArray(blueDisable)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_BLUE_DISABLE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                    bytData = SingleArrayToByteArray(SingleArrayMin2(alphaTable, True, 0, 1))
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_ALPHA_TABLE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                        bytData = BooleanToByteArray(alphaDisable)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_ALPHA_DISABLE, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                            bytData = BooleanToByteArray(clampOutput)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_TABLETRANSFER_PROP.D2D1_TABLETRANSFER_PROP_CLAMP_OUTPUT, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                
                                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1TableTransferEffect))
                
                                            End If
                
                                        End If
                
                                    End If
                
                                End If
                
                            End If
                
                        End If
                
                    End If
                
                End If
                
            End If
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1GammaTransferEffect(ByVal pID2D1Image As Long, _
                                              Optional ByVal redAmplitude As Single = 1, _
                                              Optional ByVal redExponent As Single = 1, _
                                              Optional ByVal redOffset As Single = 0, _
                                              Optional ByVal greenAmplitude As Single = 1, _
                                              Optional ByVal greenExponent As Single = 1, _
                                              Optional ByVal greenOffset As Single = 0, _
                                              Optional ByVal blueAmplitude As Single = 1, _
                                              Optional ByVal blueExponent As Single = 1, _
                                              Optional ByVal blueOffset As Single = 0, _
                                              Optional ByVal alphaAmplitude As Single = 1, _
                                              Optional ByVal alphaExponent As Single = 1, _
                                              Optional ByVal alphaOffset As Single = 0, _
                                              Optional ByVal redDisable As Boolean = False, _
                                              Optional ByVal greenDisable As Boolean = False, _
                                              Optional ByVal blueDisable As Boolean = False, _
                                              Optional ByVal alphaDisable As Boolean = False, _
                                              Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1GammaTransfer)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(redAmplitude)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_RED_AMPLITUDE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(redExponent)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_RED_EXPONENT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                    bytData = SingleToByteArray(redOffset)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_RED_OFFSET, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = BooleanToByteArray(redDisable)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_RED_DISABLE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                                
                            bytData = SingleToByteArray(greenAmplitude)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_GREEN_AMPLITUDE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                bytData = SingleToByteArray(greenExponent)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_GREEN_EXPONENT, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                    bytData = SingleToByteArray(greenOffset)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_GREEN_OFFSET, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                        bytData = BooleanToByteArray(greenDisable)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_GREEN_DISABLE, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                                
                                            bytData = SingleToByteArray(blueAmplitude)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_BLUE_AMPLITUDE, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                bytData = SingleToByteArray(blueExponent)
                                                If Invoke(pID2D1Effect, SetValue, _
                                                    D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_BLUE_EXPONENT, _
                                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                                    bytData = SingleToByteArray(blueOffset)
                                                    If Invoke(pID2D1Effect, SetValue, _
                                                        D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_BLUE_OFFSET, _
                                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                        bytData = BooleanToByteArray(blueDisable)
                                                        If Invoke(pID2D1Effect, SetValue, _
                                                            D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_BLUE_DISABLE, _
                                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                                
                                                            bytData = SingleToByteArray(alphaAmplitude)
                                                            If Invoke(pID2D1Effect, SetValue, _
                                                                D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_ALPHA_AMPLITUDE, _
                                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                                bytData = SingleToByteArray(alphaExponent)
                                                                If Invoke(pID2D1Effect, SetValue, _
                                                                    D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_ALPHA_EXPONENT, _
                                                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                                                    bytData = SingleToByteArray(alphaOffset)
                                                                    If Invoke(pID2D1Effect, SetValue, _
                                                                        D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_ALPHA_OFFSET, _
                                                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                                        bytData = BooleanToByteArray(alphaDisable)
                                                                        If Invoke(pID2D1Effect, SetValue, _
                                                                            D2D1_GAMMATRANSFER_PROP.D2D1_GAMMATRANSFER_PROP_ALPHA_DISABLE, _
                                                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                                
                                                                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1GammaTransferEffect))
                
                                                                        End If
                        
                                                                    End If
                
                                                                End If
                
                                                            End If
                
                                                        End If
                        
                                                    End If
                
                                                End If
                
                                            End If
                
                                        End If
                        
                                    End If
                
                                End If
                
                            End If
                
                        End If
                
                    End If
                
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1UnpremultiplyEffect(ByVal pID2D1Image As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1UnPremultiply)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1UnpremultiplyEffect))
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1PointSpecularEffect(ByVal pID2D1Image As Long, _
                                              ByRef color As D2D1_VECTOR_3F, _
                                              ByRef lightPosition As D2D1_VECTOR_3F, _
                                              ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                              Optional ByVal specularExponent As Single = 1, _
                                              Optional ByVal specularConstant As Single = 1, _
                                              Optional ByVal surfaceScale As Single = 1, _
                                              Optional ByVal scaleMode As D2D1_POINTSPECULAR_SCALE_MODE = D2D1_POINTSPECULAR_SCALE_MODE_LINEAR) As Long
                                             
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        specularExponent = ClampSingle(specularExponent, 1, 128)
        specularConstant = ClampSingle(specularConstant, 0, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1PointSpecular)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector3ToByteArray(lightPosition)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_LIGHT_POSITION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(specularExponent)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_SPECULAR_EXPONENT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = SingleToByteArray(specularConstant)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_SPECULAR_CONSTANT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = SingleToByteArray(surfaceScale)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_SURFACE_SCALE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = Vector3ToByteArray(color)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_COLOR, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = Vector2ToByteArray(kernelUnitLength)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_KERNEL_UNIT_LENGTH, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = LongToByteArray(scaleMode)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_POINTSPECULAR_PROP.D2D1_POINTSPECULAR_PROP_SCALE_MODE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1PointSpecularEffect))
                                        
                                    End If
                                            
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1LookupTable3DEffect(ByVal pID2D1Image As Long, _
                                              Optional alphaMode As D2D1_ALPHA_MODE = D2D1_ALPHA_MODE_PREMULTIPLIED) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    Dim pID2D1LookupTable3D As Long
    
    If pID2D1Image <> 0 Then
    
        Dim lngItem As Long
        Dim lngExtents(2) As Long
        Dim lngStrides(1) As Long
        Dim lngElements As Long
        Dim sngData() As Single
        
        lngExtents(0) = 2 'X
        lngExtents(1) = 2 'Y
        lngExtents(2) = 2 'Z
        
        lngElements = lngExtents(0) * lngExtents(1) * lngExtents(2) * 4
        
        ReDim sngData(lngElements - 1)
        
        sngData(0) = 0 'r
        sngData(1) = 0 'g
        sngData(2) = 0 'b
        sngData(3) = 1 'a
        
        sngData(4) = 1 'r
        sngData(5) = 0 'g
        sngData(6) = 0 'b
        sngData(7) = 1 'a

        sngData(8) = 0  'r
        sngData(9) = 1 'g
        sngData(10) = 0 'b
        sngData(11) = 1 'a

        sngData(12) = 1 'r
        sngData(13) = 1 'g
        sngData(14) = 0 'b
        sngData(15) = 1 'a

        sngData(16) = 0 'r
        sngData(17) = 0 'g
        sngData(18) = 1 'b
        sngData(19) = 1 'a

        sngData(20) = 1 'r
        sngData(21) = 0 'g
        sngData(22) = 1 'b
        sngData(23) = 1 'a

        sngData(24) = 0 'r
        sngData(25) = 1 'g
        sngData(26) = 1 'b
        sngData(27) = 1 'a

        sngData(28) = 1 'r
        sngData(29) = 1 'g
        sngData(30) = 1 'b
        sngData(31) = 1 'a
    
        lngStrides(0) = LngMult(16, lngExtents(0))
        lngStrides(1) = LngMult(lngStrides(0), lngExtents(0))

        bytData = SingleArrayToByteArray(sngData)
        If Invoke(m_pID2D1DeviceContext2, CreateLookupTable3D, _
            D2D1_BUFFER_PRECISION.D2D1_BUFFER_PRECISION_32BPC_FLOAT, _
            VarPtr(lngExtents(0)), VarPtr(bytData(0)), UBound(bytData) + 1, _
            VarPtr(lngStrides(0)), VarPtr(pID2D1LookupTable3D)) = S_OK Then
            
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1LookupTable3D)), _
                VarPtr(pID2D1Effect)) = S_OK Then
            
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
                bytData = LongToByteArray(pID2D1LookupTable3D)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_LOOKUPTABLE3D_PROP.D2D1_LOOKUPTABLE3D_PROP_LUT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_IUNKNOWN, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                    bytData = LongToByteArray(alphaMode)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_LOOKUPTABLE3D_PROP.D2D1_LOOKUPTABLE3D_PROP_ALPHA_MODE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1LookupTable3DEffect))
                    
                    End If
                
                End If
            
                Call Release(pID2D1Effect)
            
            End If
            
            Call Release((pID2D1LookupTable3D))
            
        End If
    
    End If
    
End Function

Public Function CreateD2D1LinearTransferEffect(ByVal pID2D1Image As Long, _
                                               Optional ByVal redYIntercept As Single = 0, _
                                               Optional ByVal greenYIntercept As Single = 0, _
                                               Optional ByVal blueYIntercept As Single = 0, _
                                               Optional ByVal alphaYIntercept As Single = 0, _
                                               Optional ByVal redSlope As Single = 1, _
                                               Optional ByVal greenSlope As Single = 1, _
                                               Optional ByVal blueSlope As Single = 1, _
                                               Optional ByVal alphaSlope As Single = 1, _
                                               Optional ByVal redDisable As Boolean = False, _
                                               Optional ByVal greenDisable As Boolean = False, _
                                               Optional ByVal blueDisable As Boolean = False, _
                                               Optional ByVal alphaDisable As Boolean = False, _
                                               Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1LinearTransfer)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(redYIntercept)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_RED_Y_INTERCEPT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(redSlope)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_RED_SLOPE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                    bytData = BooleanToByteArray(redDisable)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_RED_DISABLE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = SingleToByteArray(greenYIntercept)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_GREEN_Y_INTERCEPT, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            bytData = SingleToByteArray(greenSlope)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_GREEN_SLOPE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                bytData = BooleanToByteArray(greenDisable)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_GREEN_DISABLE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                    bytData = SingleToByteArray(blueYIntercept)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_BLUE_Y_INTERCEPT, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                        bytData = SingleToByteArray(blueSlope)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_BLUE_SLOPE, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                            bytData = BooleanToByteArray(blueDisable)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_BLUE_DISABLE, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                bytData = SingleToByteArray(alphaYIntercept)
                                                If Invoke(pID2D1Effect, SetValue, _
                                                    D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_ALPHA_Y_INTERCEPT, _
                                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                    bytData = SingleToByteArray(alphaSlope)
                                                    If Invoke(pID2D1Effect, SetValue, _
                                                        D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_ALPHA_SLOPE, _
                                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                                        bytData = BooleanToByteArray(alphaDisable)
                                                        If Invoke(pID2D1Effect, SetValue, _
                                                            D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_ALPHA_DISABLE, _
                                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                                            bytData = BooleanToByteArray(clampOutput)
                                                            If Invoke(pID2D1Effect, SetValue, _
                                                                D2D1_LINEARTRANSFER_PROP.D2D1_LINEARTRANSFER_PROP_CLAMP_OUTPUT, _
                                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                                
                                                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1LinearTransferEffect))
                                                                
                                                            End If
                                
                                                        End If
                
                                                    End If
                
                                                End If
                                
                                            End If
                
                                        End If
                
                                    End If
                                
                                End If
                
                            End If
                
                        End If
                
                    End If
                
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1ConvolveMatrixEffect(ByVal pID2D1Image As Long, _
                                               ByRef kernelMatrix() As Single, _
                                               ByRef kernelOffset As D2D1_VECTOR_2F, _
                                               ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                               Optional ByVal divisor As Single = 1, _
                                               Optional ByVal bias As Single = 0, _
                                               Optional ByVal kernelSizeX As Long = 3, _
                                               Optional ByVal kernelSizeY As Long = 3, _
                                               Optional ByVal preserveAlpha As Boolean = False, _
                                               Optional ByVal clampOutput As Boolean = False, _
                                               Optional ByVal scaleMode As D2D1_CONVOLVEMATRIX_SCALE_MODE = D2D1_CONVOLVEMATRIX_SCALE_MODE_LINEAR, _
                                               Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If kernelSizeX < 3 Then kernelSizeX = 3
        If kernelSizeY < 3 Then kernelSizeX = 3
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1ConvolveMatrix)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector2ToByteArray(kernelUnitLength)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_KERNEL_UNIT_LENGTH, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(scaleMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_SCALE_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                    bytData = LongToByteArray(kernelSizeX)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_KERNEL_SIZE_X, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = LongToByteArray(kernelSizeY)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_KERNEL_SIZE_Y, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_UINT32, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                            bytData = SingleArrayToByteArray(SingleArrayMin9(kernelMatrix))
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_KERNEL_MATRIX, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                bytData = SingleToByteArray(divisor)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_DIVISOR, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                    bytData = SingleToByteArray(bias)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_BIAS, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                        bytData = Vector2ToByteArray(kernelOffset)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_KERNEL_OFFSET, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                            bytData = BooleanToByteArray(preserveAlpha)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_PRESERVE_ALPHA, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                
                                                bytData = LongToByteArray(borderMode)
                                                If Invoke(pID2D1Effect, SetValue, _
                                                    D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_BORDER_MODE, _
                                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                
                                                    bytData = BooleanToByteArray(clampOutput)
                                                    If Invoke(pID2D1Effect, SetValue, _
                                                        D2D1_CONVOLVEMATRIX_PROP.D2D1_CONVOLVEMATRIX_PROP_CLAMP_OUTPUT, _
                                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                
                                                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ConvolveMatrixEffect))
                
                                                    End If
                
                                                End If
                
                                            End If
                
                                        End If
                
                                    End If
                
                                End If
                
                            End If
                
                        End If
                
                    End If
                
                End If
                
            End If
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1DistantDiffuseEffect(ByVal pID2D1Image As Long, _
                                               ByRef color As D2D1_VECTOR_3F, _
                                               ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                               Optional ByVal azimuth As Single = 0, _
                                               Optional ByVal elevation As Single = 0, _
                                               Optional ByVal diffuseConstant As Single = 1, _
                                               Optional ByVal surfaceScale As Single = 1, _
                                               Optional ByVal scaleMode As D2D1_DISTANTDIFFUSE_SCALE_MODE = D2D1_DISTANTDIFFUSE_SCALE_MODE_LINEAR) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        azimuth = ClampSingle(azimuth, 0, 360)
        elevation = ClampSingle(elevation, 0, 360)
        diffuseConstant = ClampSingle(diffuseConstant, 0, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1DistantDiffuse)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(azimuth)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_AZIMUTH, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(elevation)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_ELEVATION, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(diffuseConstant)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_DIFFUSE_CONSTANT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = SingleToByteArray(surfaceScale)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_SURFACE_SCALE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = Vector3ToByteArray(color)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_COLOR, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = Vector2ToByteArray(kernelUnitLength)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_KERNEL_UNIT_LENGTH, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = LongToByteArray(scaleMode)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_DISTANTDIFFUSE_PROP.D2D1_DISTANTDIFFUSE_PROP_SCALE_MODE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DistantDiffuseEffect))
                                            
                                    End If
                                    
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1ColorManagementEffect(ByVal pID2D1Image As Long, _
                                                Optional ByVal sourceColorSpace As D2D1_COLOR_SPACE = D2D1_COLOR_SPACE_SRGB, _
                                                Optional ByVal sourceRenderingIntent As D2D1_COLORMANAGEMENT_RENDERING_INTENT = D2D1_COLORMANAGEMENT_RENDERING_INTENT_PERCEPTUAL, _
                                                Optional ByVal destinationColorSpace As D2D1_COLOR_SPACE = D2D1_COLOR_SPACE_SRGB, _
                                                Optional ByVal destinationRenderingIntent As D2D1_COLORMANAGEMENT_RENDERING_INTENT = D2D1_COLORMANAGEMENT_RENDERING_INTENT_PERCEPTUAL, _
                                                Optional ByVal alphaMode As D2D1_COLORMANAGEMENT_ALPHA_MODE = D2D1_COLORMANAGEMENT_ALPHA_MODE_PREMULTIPLIED, _
                                                Optional ByVal qualityMode As D2D1_COLORMANAGEMENT_QUALITY = D2D1_COLORMANAGEMENT_QUALITY_NORMAL) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    Dim pID2D1ColorContextSrc As Long
    Dim pID2D1ColorContextDst As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateColorContext, sourceColorSpace, _
            0&, 0&, VarPtr(pID2D1ColorContextSrc)) = S_OK Then
            
            If Invoke(m_pID2D1DeviceContext2, CreateColorContext, destinationColorSpace, _
                0&, 0&, VarPtr(pID2D1ColorContextDst)) = S_OK Then
    
                If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                    VarPtr(Str2Guid(CLSID_D2D1ColorManagement)), _
                    VarPtr(pID2D1Effect)) = S_OK Then
            
                    Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
                    bytData = LongToByteArray(pID2D1ColorContextSrc)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_SOURCE_COLOR_CONTEXT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_COLOR_CONTEXT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = LongToByteArray(sourceRenderingIntent)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_SOURCE_RENDERING_INTENT, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = LongToByteArray(pID2D1ColorContextDst)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_DESTINATION_COLOR_CONTEXT, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_COLOR_CONTEXT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = LongToByteArray(destinationRenderingIntent)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_DESTINATION_RENDERING_INTENT, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = LongToByteArray(alphaMode)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_ALPHA_MODE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        bytData = LongToByteArray(qualityMode)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_COLORMANAGEMENT_PROP.D2D1_COLORMANAGEMENT_PROP_QUALITY, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                            
                                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ColorManagementEffect))
                                                
                                        End If
                                    
                                    End If
                                
                                End If
                            
                            End If
                        
                        End If
                    
                    End If
            
                    Call Release(pID2D1Effect)
            
                End If
        
            End If
            
            Call Release(pID2D1ColorContextDst)
            
        End If
    
        Call Release(pID2D1ColorContextSrc)
            
    End If
    
End Function


Public Function CreateD2D1DpiCompensationEffect(ByVal pID2D1Image As Long, _
                                                ByRef inputDPI As D2D1_VECTOR_2F, _
                                                Optional ByVal interpolationMode As D2D1_DPICOMPENSATION_INTERPOLATION_MODE = D2D1_DPICOMPENSATION_INTERPOLATION_MODE_LINEAR, _
                                                Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If inputDPI.x < 1 Then inputDPI.x = 1
        If inputDPI.y < 1 Then inputDPI.y = 1
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1DpiCompensation)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(interpolationMode)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_DPICOMPENSATION_PROP.D2D1_DPICOMPENSATION_PROP_INTERPOLATION_MODE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(borderMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DPICOMPENSATION_PROP.D2D1_DPICOMPENSATION_PROP_BORDER_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = Vector2ToByteArray(inputDPI)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DPICOMPENSATION_PROP.D2D1_DPICOMPENSATION_PROP_INPUT_DPI, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DpiCompensationEffect))
                        
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1DirectionalBlurEffect(ByVal pID2D1Image As Long, _
                                                Optional ByVal deviation As Single = 3, _
                                                Optional ByVal angle As Single = 0, _
                                                Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT, _
                                                Optional ByVal optimization As D2D1_DIRECTIONALBLUR_OPTIMIZATION = D2D1_DIRECTIONALBLUR_OPTIMIZATION_BALANCED) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        angle = ClampSingle(angle, 0, 360)
        deviation = ClampSingle(deviation, 0, 100)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1DirectionalBlur)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(deviation)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_DIRECTIONALBLUR_PROP.D2D1_DIRECTIONALBLUR_PROP_STANDARD_DEVIATION, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(angle)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DIRECTIONALBLUR_PROP.D2D1_DIRECTIONALBLUR_PROP_ANGLE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    bytData = LongToByteArray(optimization)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DIRECTIONALBLUR_PROP.D2D1_DIRECTIONALBLUR_PROP_OPTIMIZATION, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = LongToByteArray(borderMode)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_DIRECTIONALBLUR_PROP.D2D1_DIRECTIONALBLUR_PROP_BORDER_MODE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DirectionalBlurEffect))
                        
                        End If
                
                    End If
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1TemperatureTintEffect(ByVal pID2D1Image As Long, _
                                                Optional ByVal temperature As Single = 0, _
                                                Optional ByVal tint As Single = 0) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        tint = ClampSingle(tint, -1, 1)
        temperature = ClampSingle(temperature, -1, 1)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1TemperatureTint)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(temperature)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_TEMPERATUREANDTINT_PROP.D2D1_TEMPERATUREANDTINT_PROP_TEMPERATURE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(tint)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_TEMPERATUREANDTINT_PROP.D2D1_TEMPERATUREANDTINT_PROP_TINT, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1TemperatureTintEffect))
                        
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1DisplacementMapEffect(ByVal pID2D1Image0 As Long, _
                                                ByVal pID2D1Image1 As Long, _
                                                Optional ByVal displacementScale As Single = 0, _
                                                Optional ByVal channelSelectX As D2D1_CHANNEL_SELECTOR = D2D1_CHANNEL_SELECTOR_A, _
                                                Optional ByVal channelSelectY As D2D1_CHANNEL_SELECTOR = D2D1_CHANNEL_SELECTOR_A) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 Then
        If pID2D1Image1 <> 0 Then
    
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1DisplacementMap)), _
                VarPtr(pID2D1Effect)) = S_OK Then
            
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
                Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
            
                bytData = SingleToByteArray(displacementScale)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DISPLACEMENTMAP_PROP.D2D1_DISPLACEMENTMAP_PROP_SCALE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = LongToByteArray(channelSelectX)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DISPLACEMENTMAP_PROP.D2D1_DISPLACEMENTMAP_PROP_X_CHANNEL_SELECT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = LongToByteArray(channelSelectY)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_DISPLACEMENTMAP_PROP.D2D1_DISPLACEMENTMAP_PROP_Y_CHANNEL_SELECT, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DisplacementMapEffect))
                        
                        End If
                        
                    End If
                        
                End If
            
                Call Release(pID2D1Effect)
            
            End If
            
        End If
    
    End If

End Function

Public Function CreateD2D1DistantSpecularEffect(ByVal pID2D1Image As Long, _
                                                ByRef color As D2D1_VECTOR_3F, _
                                                ByRef kernelUnitLength As D2D1_VECTOR_2F, _
                                                Optional ByVal azimuth As Single = 0, _
                                                Optional ByVal elevation As Single = 0, _
                                                Optional ByVal specularExponent As Single = 1, _
                                                Optional ByVal specularConstant As Single = 1, _
                                                Optional ByVal surfaceScale As Single = 1, _
                                                Optional ByVal scaleMode As D2D1_DISTANTSPECULAR_SCALE_MODE = D2D1_DISTANTSPECULAR_SCALE_MODE_LINEAR) As Long
    
    Dim bytData() As Byte
    Dim pID2D1Effect As Long
    
    If pID2D1Image <> 0 Then
    
        azimuth = ClampSingle(azimuth, 0, 360)
        elevation = ClampSingle(elevation, 0, 360)
        specularExponent = ClampSingle(specularExponent, 1, 128)
        specularConstant = ClampSingle(specularConstant, 1, 10000)
        surfaceScale = ClampSingle(surfaceScale, 0, 10000)
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1DistantSpecular)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(azimuth)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_AZIMUTH, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(elevation)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_ELEVATION, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(specularExponent)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_SPECULAR_EXPONENT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = SingleToByteArray(specularConstant)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_SPECULAR_CONSTANT, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = SingleToByteArray(surfaceScale)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_SURFACE_SCALE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = Vector3ToByteArray(color)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_COLOR, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = Vector2ToByteArray(kernelUnitLength)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_KERNEL_UNIT_LENGTH, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        bytData = BooleanToByteArray(scaleMode)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_DISTANTSPECULAR_PROP.D2D1_DISTANTSPECULAR_PROP_SCALE_MODE, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DistantSpecularEffect))
                                            
                                        End If
                                            
                                    End If
                                    
                                End If
                                
                            End If
                            
                        End If
                        
                    End If
                    
                End If
                
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1OpacityMetadataEffect(ByVal pID2D1Image As Long, _
                                                ByRef opaqueRect As D2D1_VECTOR_4F) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1OpacityMetadata)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = Vector4ToByteArray(opaqueRect)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_OPACITYMETADATA_PROP.D2D1_OPACITYMETADATA_PROP_INPUT_OPAQUE_RECT, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1OpacityMetadataEffect))
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1DiscreteTransferEffect(ByVal pID2D1Image As Long, _
                                                 ByRef redTable() As Single, _
                                                 ByRef greenTable() As Single, _
                                                 ByRef blueTable() As Single, _
                                                 ByRef alphaTable() As Single, _
                                                 Optional ByVal redDisable As Boolean = False, _
                                                 Optional ByVal greenDisable As Boolean = False, _
                                                 Optional ByVal blueDisable As Boolean = False, _
                                                 Optional ByVal alphaDisable As Boolean = False, _
                                                 Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1DiscreteTransfer)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleArrayToByteArray(SingleArrayMin2(redTable, True, 0, 1))
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_RED_TABLE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = BooleanToByteArray(redDisable)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_RED_DISABLE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                    bytData = SingleArrayToByteArray(SingleArrayMin2(greenTable, True, 0, 1))
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_GREEN_TABLE, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = BooleanToByteArray(greenDisable)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_GREEN_DISABLE, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                            bytData = SingleArrayToByteArray(SingleArrayMin2(blueTable, True, 0, 1))
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_BLUE_TABLE, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                bytData = BooleanToByteArray(blueDisable)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_BLUE_DISABLE, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                    bytData = SingleArrayToByteArray(SingleArrayMin2(alphaTable, True, 0, 1))
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_ALPHA_TABLE, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BLOB, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                                        bytData = BooleanToByteArray(alphaDisable)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_ALPHA_DISABLE, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
            
                                            bytData = BooleanToByteArray(clampOutput)
                                            If Invoke(pID2D1Effect, SetValue, _
                                                D2D1_DISCRETETRANSFER_PROP.D2D1_DISCRETETRANSFER_PROP_CLAMP_OUTPUT, _
                                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                                
                                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1DiscreteTransferEffect))
                
                                            End If
                
                                        End If
                
                                    End If
                
                                End If
                
                            End If
                
                        End If
                
                    End If
                
                End If
                
            End If
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1LuminanceToAlphaEffect(ByVal pID2D1Image As Long) As Long

    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1LuminanceToAlpha)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
                        
            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1LuminanceToAlphaEffect))
                        
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D1HighlightsShadowsEffect(ByVal pID2D1Image As Long, _
                                                  Optional ByVal highlights As Single = 0, _
                                                  Optional ByVal shadows As Single = 0, _
                                                  Optional ByVal clarity As Single = 0, _
                                                  Optional ByVal maskBlurRadius As Single = 1.25, _
                                                  Optional ByVal inputGamma As D2D1_HIGHLIGHTSANDSHADOWS_INPUT_GAMMA = D2D1_HIGHLIGHTSANDSHADOWS_INPUT_GAMMA_LINEAR) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        highlights = ClampSingle(highlights, -1, 1)
        shadows = ClampSingle(shadows, -1, 1)
        clarity = ClampSingle(clarity, -1, 1)
        maskBlurRadius = ClampSingle(maskBlurRadius, 0, 10)
        
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1HighlightsShadows)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(highlights)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_HIGHLIGHTSANDSHADOWS_PROP.D2D1_HIGHLIGHTSANDSHADOWS_PROP_HIGHLIGHTS, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(shadows)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_HIGHLIGHTSANDSHADOWS_PROP.D2D1_HIGHLIGHTSANDSHADOWS_PROP_SHADOWS, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = SingleToByteArray(clarity)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_HIGHLIGHTSANDSHADOWS_PROP.D2D1_HIGHLIGHTSANDSHADOWS_PROP_CLARITY, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = SingleToByteArray(maskBlurRadius)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_HIGHLIGHTSANDSHADOWS_PROP.D2D1_HIGHLIGHTSANDSHADOWS_PROP_MASK_BLUR_RADIUS, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            bytData = LongToByteArray(inputGamma)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_HIGHLIGHTSANDSHADOWS_PROP.D2D1_HIGHLIGHTSANDSHADOWS_PROP_INPUT_GAMMA, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                                Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1HighlightsShadowsEffect))
                            
                            End If
                        
                        End If
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D12DAffineTransformEffect(ByVal pID2D1Image As Long, _
                                                  ByRef tranformMatrix As D2D1_MATRIX_3X2_F, _
                                                  Optional interpolationMode As D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE = D2D1_2DAFFINETRANSFORM_INTERPOLATION_MODE_LINEAR, _
                                                  Optional sharpness As Single = 1, _
                                                  Optional borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then

        sharpness = ClampSingle(sharpness, 0, 1)

        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D12DAffineTransform)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(interpolationMode)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_2DAFFINETRANSFORM_PROP.D2D1_2DAFFINETRANSFORM_PROP_INTERPOLATION_MODE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(borderMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_2DAFFINETRANSFORM_PROP.D2D1_2DAFFINETRANSFORM_PROP_BORDER_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    bytData = Matrix_3X2ToByteArray(tranformMatrix)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_2DAFFINETRANSFORM_PROP.D2D1_2DAFFINETRANSFORM_PROP_TRANSFORM_MATRIX, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_MATRIX_3X2, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                        bytData = SingleToByteArray(sharpness)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_2DAFFINETRANSFORM_PROP.D2D1_2DAFFINETRANSFORM_PROP_SHARPNESS, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D12DAffineTransformEffect))
                        
                        End If
                        
                    End If
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
        
    End If
    
End Function

Public Function CreateD2D1ArithmeticCompositeEffect(ByVal pID2D1Image0 As Long, _
                                                    ByVal pID2D1Image1 As Long, _
                                                    ByRef coefficients As D2D1_VECTOR_4F, _
                                                    Optional ByVal clampOutput As Boolean = False) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image0 <> 0 Then
        If pID2D1Image1 <> 0 Then
    
            If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
                VarPtr(Str2Guid(CLSID_D2D1ArithmeticComposite)), _
                VarPtr(pID2D1Effect)) = S_OK Then
                
                Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image0, 1&)
                Call Invoke(pID2D1Effect, SetInput, 1&, pID2D1Image1, 1&)
                
                bytData = Vector4ToByteArray(coefficients)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_ARITHMETICCOMPOSITE_PROP.D2D1_ARITHMETICCOMPOSITE_PROP_COEFFICIENTS, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR4, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = BooleanToByteArray(clampOutput)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_ARITHMETICCOMPOSITE_PROP.D2D1_ARITHMETICCOMPOSITE_PROP_CLAMP_OUTPUT, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_BOOL, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                        Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1ArithmeticCompositeEffect))
                            
                    End If
                        
                End If
            
                Call Release(pID2D1Effect)
            
            End If
            
        End If
    
    End If

End Function

Public Function CreateD2D1WhiteLevelAdjustmentEffect(ByVal pID2D1Image As Long, _
                                                     Optional ByVal inputWhiteLevel As Single = 80, _
                                                     Optional ByVal outputWhiteLevel As Single = 80) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If inputWhiteLevel < 1 Then inputWhiteLevel = 1
        If outputWhiteLevel < 1 Then outputWhiteLevel = 1
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D1WhiteLevelAdjustment)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = SingleToByteArray(inputWhiteLevel)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_WHITELEVELADJUSTMENT_PROP.D2D1_WHITELEVELADJUSTMENT_PROP_INPUT_WHITE_LEVEL, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = SingleToByteArray(outputWhiteLevel)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_WHITELEVELADJUSTMENT_PROP.D2D1_WHITELEVELADJUSTMENT_PROP_OUTPUT_WHITE_LEVEL, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                    Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D1WhiteLevelAdjustmentEffect))
                        
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function CreateD2D13DPerspectiveTransformEffect(ByVal pID2D1Image As Long, _
                                                       ByRef perspectiveOrigin As D2D1_VECTOR_2F, _
                                                       ByRef localOffset As D2D1_VECTOR_3F, _
                                                       ByRef globalOffset As D2D1_VECTOR_3F, _
                                                       ByRef rotationOrigin As D2D1_VECTOR_3F, _
                                                       ByRef rotation As D2D1_VECTOR_3F, _
                                                       Optional ByVal depth As Single = 1000, _
                                                       Optional ByVal interpolationMode As D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE = D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_LINEAR, _
                                                       Optional ByVal borderMode As D2D1_BORDER_MODE = D2D1_BORDER_MODE_SOFT) As Long

    Dim bytData() As Byte
    Dim pID2D1Effect As Long

    If pID2D1Image <> 0 Then
    
        If depth < 1 Then depth = 1
    
        If Invoke(m_pID2D1DeviceContext2, CreateEffect, _
            VarPtr(Str2Guid(CLSID_D2D13DPerspectiveTransform)), _
            VarPtr(pID2D1Effect)) = S_OK Then
            
            Call Invoke(pID2D1Effect, SetInput, 0&, pID2D1Image, 1&)
            
            bytData = LongToByteArray(interpolationMode)
            If Invoke(pID2D1Effect, SetValue, _
                D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_INTERPOLATION_MODE, _
                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                
                bytData = LongToByteArray(borderMode)
                If Invoke(pID2D1Effect, SetValue, _
                    D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_BORDER_MODE, _
                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_ENUM, _
                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                    
                    bytData = SingleToByteArray(depth)
                    If Invoke(pID2D1Effect, SetValue, _
                        D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_DEPTH, _
                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_FLOAT, _
                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                        
                        bytData = Vector2ToByteArray(perspectiveOrigin)
                        If Invoke(pID2D1Effect, SetValue, _
                            D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_PERSPECTIVE_ORIGIN, _
                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR2, _
                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                            
                            bytData = Vector3ToByteArray(localOffset)
                            If Invoke(pID2D1Effect, SetValue, _
                                D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_LOCAL_OFFSET, _
                                D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                
                                bytData = Vector3ToByteArray(globalOffset)
                                If Invoke(pID2D1Effect, SetValue, _
                                    D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_GLOBAL_OFFSET, _
                                    D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                    VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                    
                                    bytData = Vector3ToByteArray(rotationOrigin)
                                    If Invoke(pID2D1Effect, SetValue, _
                                        D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION_ORIGIN, _
                                        D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                        VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                        
                                        bytData = Vector3ToByteArray(rotation)
                                        If Invoke(pID2D1Effect, SetValue, _
                                            D2D1_3DPERSPECTIVETRANSFORM_PROP.D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION, _
                                            D2D1_PROPERTY_TYPE.D2D1_PROPERTY_TYPE_VECTOR3, _
                                            VarPtr(bytData(0)), UBound(bytData) + 1) = S_OK Then
                                            
                                            Call Invoke(pID2D1Effect, GetOutput, VarPtr(CreateD2D13DPerspectiveTransformEffect))
                                                
                                        End If
                                            
                                    End If
                                        
                                End If
                                        
                            End If
                                    
                        End If
                                
                    End If
                            
                End If
                        
            End If
            
            Call Release(pID2D1Effect)
            
        End If
    
    End If

End Function

Public Function NewRect_F(Optional ByVal left As Single = 0, _
                          Optional ByVal top As Single = 0, _
                          Optional ByVal right As Single = 0, _
                          Optional ByVal bottom As Single = 0) As D2D1_RECT_F
    
    With NewRect_F
        .left = left
        .top = top
        .right = right
        .bottom = bottom
    End With

End Function

Public Function NewPoint_2F(Optional ByVal x As Single = 0, _
                            Optional ByVal y As Single = 0) As D2D1_POINT_2F

    With NewPoint_2F
        .x = x
        .y = y
    End With

End Function


Public Function NewColor_F(Optional ByVal a As Single = 0, _
                           Optional ByVal r As Single = 0, _
                           Optional ByVal g As Single = 0, _
                           Optional ByVal b As Single = 0) As D2D1_COLOR_F
                           
    With NewColor_F
        .a = a
        .r = r
        .g = g
        .b = b
    End With

End Function

Public Function NewVector_2F(Optional ByVal x As Single = 0, _
                             Optional ByVal y As Single = 0) As D2D1_VECTOR_2F

    With NewVector_2F
        .x = x
        .y = y
    End With

End Function

Public Function NewVector_3F(Optional ByVal x As Single = 0, _
                             Optional ByVal y As Single = 0, _
                             Optional ByVal z As Single = 0) As D2D1_VECTOR_3F

    With NewVector_3F
        .x = x
        .y = y
        .z = z
    End With

End Function

Public Function NewVector_4F(Optional ByVal x As Single = 0, _
                             Optional ByVal y As Single = 0, _
                             Optional ByVal z As Single = 0, _
                             Optional ByVal w As Single = 0) As D2D1_VECTOR_4F

    With NewVector_4F
        .x = x
        .y = y
        .z = z
        .w = w
    End With

End Function

Public Function NewMatrix_3X2(Optional ByVal m_11 As Single = 1, _
                              Optional ByVal m_12 As Single = 0, _
                              Optional ByVal m_21 As Single = 0, _
                              Optional ByVal m_22 As Single = 1, _
                              Optional ByVal m_31 As Single = 0, _
                              Optional ByVal m_32 As Single = 0) As D2D1_MATRIX_3X2_F

    With NewMatrix_3X2
        .m_11 = m_11
        .m_12 = m_12
        .m_21 = m_21
        .m_22 = m_22
        .m_31 = m_31
        .m_32 = m_32
    End With

End Function

Public Function NewMatrix_4X4(Optional ByVal m_00 As Single = 1, _
                              Optional ByVal m_01 As Single = 0, _
                              Optional ByVal m_02 As Single = 0, _
                              Optional ByVal m_03 As Single = 0, _
                              Optional ByVal m_10 As Single = 0, _
                              Optional ByVal m_11 As Single = 1, _
                              Optional ByVal m_12 As Single = 0, _
                              Optional ByVal m_13 As Single = 0, _
                              Optional ByVal m_20 As Single = 0, _
                              Optional ByVal m_21 As Single = 0, _
                              Optional ByVal m_22 As Single = 1, _
                              Optional ByVal m_23 As Single = 0, _
                              Optional ByVal m_30 As Single = 0, _
                              Optional ByVal m_31 As Single = 0, _
                              Optional ByVal m_32 As Single = 0, _
                              Optional ByVal m_33 As Single = 1) As D2D1_MATRIX_4X4_F

    With NewMatrix_4X4
        .m_00 = m_00
        .m_01 = m_01
        .m_02 = m_02
        .m_03 = m_03
        .m_10 = m_10
        .m_11 = m_11
        .m_12 = m_12
        .m_13 = m_13
        .m_20 = m_20
        .m_21 = m_21
        .m_22 = m_22
        .m_23 = m_23
        .m_30 = m_30
        .m_31 = m_31
        .m_32 = m_32
        .m_33 = m_33
    End With

End Function

Public Function NewMatrix_5X4(Optional ByVal m_00 As Single = 1, _
                              Optional ByVal m_01 As Single = 0, _
                              Optional ByVal m_02 As Single = 0, _
                              Optional ByVal m_03 As Single = 0, _
                              Optional ByVal m_10 As Single = 0, _
                              Optional ByVal m_11 As Single = 1, _
                              Optional ByVal m_12 As Single = 0, _
                              Optional ByVal m_13 As Single = 0, _
                              Optional ByVal m_20 As Single = 0, _
                              Optional ByVal m_21 As Single = 0, _
                              Optional ByVal m_22 As Single = 1, _
                              Optional ByVal m_23 As Single = 0, _
                              Optional ByVal m_30 As Single = 0, _
                              Optional ByVal m_31 As Single = 0, _
                              Optional ByVal m_32 As Single = 0, _
                              Optional ByVal m_33 As Single = 1, _
                              Optional ByVal m_40 As Single = 0, _
                              Optional ByVal m_41 As Single = 0, _
                              Optional ByVal m_42 As Single = 0, _
                              Optional ByVal m_43 As Single = 0) As D2D1_MATRIX_5X4_F

    With NewMatrix_5X4
        .m_00 = m_00
        .m_01 = m_01
        .m_02 = m_02
        .m_03 = m_03
        .m_10 = m_10
        .m_11 = m_11
        .m_12 = m_12
        .m_13 = m_13
        .m_20 = m_20
        .m_21 = m_21
        .m_22 = m_22
        .m_23 = m_23
        .m_30 = m_30
        .m_31 = m_31
        .m_32 = m_32
        .m_33 = m_33
        .m_40 = m_40
        .m_41 = m_41
        .m_42 = m_42
        .m_43 = m_43
    End With

End Function

Public Function NewSingleArray(ParamArray values()) As Single()

    Dim lngItem As Long
    Dim lngCount As Long
    Dim sngOut() As Single

    lngCount = UBound(values)
    
    If lngCount >= 0 Then
        
        ReDim sngOut(lngCount)
        
        For lngItem = 0 To lngCount
        
            sngOut(lngItem) = CSng(values(lngItem))
        
        Next

    End If

    NewSingleArray = sngOut

End Function


' ----==== Call OleInvoke ====----
Private Function Invoke(ByVal pInterface As Long, _
    ByVal eInterfaceFunction As vtb_Interfaces, _
    ParamArray arrParam()) As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then
        
        ' Call OleInvoke
        Invoke = OleInvoke(pInterface, eInterfaceFunction, arrParam)

    End If

End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim varRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, _
            vbLong, 0&, 0&, 0&, varRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lngCmd As Long, _
    ParamArray arrParam()) As Variant
    
    Dim lngItem As Long
    Dim lngCount As Long
    Dim varRet As Variant
    Dim varParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion
        ' auch Parameter vorhanden sind.
        If UBound(arrParam) >= 0 Then

            ' ParamArray nach Variant
            varParam = arrParam

            ' ist der Variant ein Array
            If IsArray(varParam) Then varParam = varParam(0)

            ' Anzahl der Parameter
            lngCount = UBound(varParam)

            ' alle Parameter durchlaufen
            For lngItem = 0 To lngCount

                ' Typ des Parameter
                oleTyp(lngItem) = VarType(varParam(lngItem))

                ' Pointer auf den Parameter
                olePtr(lngItem) = VarPtr(varParam(lngItem))

            Next

        End If

        ' Funktion des Interfaces ausfhren
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, vbLong, _
            lngItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), varRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
            
        End If
        
    End If

    OleInvoke = varRet

End Function

' ----==== String -> GUID ====----
Private Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

Private Function BooleanToByteArray(ByVal value As Boolean) As Byte()
    
    Dim bytData() As Byte
    Dim lngBool As Long
    Dim lngDataSize As Long
    lngBool = Abs(value)
    lngDataSize = LenB(lngBool)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), lngBool, lngDataSize)
    BooleanToByteArray = bytData

End Function

Private Function SingleToByteArray(ByVal value As Single) As Byte()
    
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    SingleToByteArray = bytData

End Function

Private Function SingleArrayToByteArray(ByRef value() As Single) As Byte()
    
    Dim lngCount As Long
    Dim lngDataSize As Long
    Dim bytData() As Byte
    lngCount = UBound(value) + 1
    lngDataSize = LenB(value(0))
    ReDim bytData((lngCount * lngDataSize) - 1)
    Call CopyMemory(bytData(0), value(0), lngCount * lngDataSize)
    SingleArrayToByteArray = bytData
    
End Function

Private Function LongToByteArray(ByVal value As Long) As Byte()
    
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    LongToByteArray = bytData

End Function

Private Function Vector2ToByteArray(ByRef value As D2D1_VECTOR_2F) As Byte()
    
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Vector2ToByteArray = bytData

End Function

Private Function Vector3ToByteArray(ByRef value As D2D1_VECTOR_3F) As Byte()
    
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Vector3ToByteArray = bytData

End Function

Private Function Vector4ToByteArray(ByRef value As D2D1_VECTOR_4F) As Byte()
    
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Vector4ToByteArray = bytData

End Function

Private Function Matrix_3X2ToByteArray(ByRef value As D2D1_MATRIX_3X2_F) As Byte()

    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Matrix_3X2ToByteArray = bytData

End Function

Private Function Matrix_4X4ToByteArray(ByRef value As D2D1_MATRIX_4X4_F) As Byte()

    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Matrix_4X4ToByteArray = bytData

End Function

Private Function Matrix_5X4ToByteArray(ByRef value As D2D1_MATRIX_5X4_F) As Byte()

    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), value, lngDataSize)
    Matrix_5X4ToByteArray = bytData

End Function


Private Function ClampSingle(ByVal value As Single, _
                             ByVal minValue As Single, _
                             ByVal maxValue As Single) As Single
    
    If value < minValue Then
        ClampSingle = minValue
        Exit Function
    ElseIf value > maxValue Then
        ClampSingle = maxValue
        Exit Function
    Else
        ClampSingle = value
    End If

End Function

Private Function ClampLong(ByVal value As Long, _
                           ByVal minValue As Long, _
                           ByVal maxValue As Long) As Long
    
    If value < minValue Then
        ClampLong = minValue
        Exit Function
    ElseIf value > maxValue Then
        ClampLong = maxValue
        Exit Function
    Else
        ClampLong = value
    End If

End Function

Private Function ArrayIsInitialized(ByRef arr As Variant) As Boolean

  Dim memVal As Long

  Call CopyMemory(memVal, ByVal VarPtr(arr) + 8, 4)
  Call CopyMemory(memVal, ByVal memVal, 4)
  
  ArrayIsInitialized = (memVal <> 0)

End Function

Private Function SingleArrayMin2(ByRef arrIn() As Single, _
                                 Optional ByVal clamp As Boolean = False, _
                                 Optional ByVal minValue As Single = 0, _
                                 Optional ByVal maxValue As Single = 1) As Single()

    Dim lngItem As Long
    Dim lngItems As Long
    Dim lngCount As Long
    Dim arrOut() As Single
    
    If ArrayIsInitialized(arrIn) Then
    
        lngItems = UBound(arrIn)
        
        If lngItems < 1 Then
            ReDim arrOut(1)
            lngCount = 1
        Else
            ReDim arrOut(lngItems)
            lngCount = lngItems
        End If
    
        For lngItem = 0 To lngCount
            
            If lngItem <= lngItems Then
            
                If clamp Then
            
                    arrOut(lngItem) = ClampSingle(arrIn(lngItem), minValue, maxValue)
                    
                Else
                
                    arrOut(lngItem) = arrIn(lngItem)
                
                End If
            
            End If
                
        Next
            
    Else
    
        ReDim arrOut(1)
        arrOut(1) = 1
        
    End If
    
    SingleArrayMin2 = arrOut
    
End Function

Private Function SingleArrayMin9(ByRef arrIn() As Single, _
                                 Optional ByVal clamp As Boolean = False, _
                                 Optional ByVal minValue As Single = 0, _
                                 Optional ByVal maxValue As Single = 1) As Single()

    Dim lngItem As Long
    Dim lngItems As Long
    Dim lngCount As Long
    Dim arrOut() As Single
    
    If ArrayIsInitialized(arrIn) Then
    
        lngItems = UBound(arrIn)
        
        If lngItems < 8 Then
            ReDim arrOut(8)
            lngCount = 8
        Else
            ReDim arrOut(lngItems)
            lngCount = lngItems
        End If
        
        arrOut(4) = 1
    
        For lngItem = 0 To lngCount
            
            If lngItem <= lngItems Then
            
                If clamp Then
            
                    arrOut(lngItem) = ClampSingle(arrIn(lngItem), minValue, maxValue)
                    
                Else
                
                    arrOut(lngItem) = arrIn(lngItem)
                
                End If
            
            End If
                
        Next
        
    Else
    
        ReDim arrOut(8)
        arrOut(4) = 1
        
    End If
    
    SingleArrayMin9 = arrOut
    
End Function

Private Function LngMult(ByVal lngMultiplicand As Long, ByVal lngMultiplier As Long) As Long
    
    LngMult = lngMultiplicand * lngMultiplier
    
End Function

' ----==== http://www.vbforums.com/showthread.php?p=4939815#post4939815 ====----
Private Sub Convert(ByRef vPic As IPicture)
    
    If m_IPicture_VTable = 0& Then
        
        Call CopyMemory(m_IPicture_VTable, ByVal ObjPtr(vPic), 4&)

        Call CopyMemory(m_IPicture_Renderer, ByVal m_IPicture_VTable + 32&, 4&)
        Call SetVTableEntry(m_IPicture_VTable + 32&, AddressOf NewRender)

        Call CopyMemory(m_IPicture_Attributes, ByVal m_IPicture_VTable + 64&, 4&)
        Call SetVTableEntry(m_IPicture_VTable + 64&, AddressOf NewAttributes)
        
    End If
    
End Sub

Private Sub Unconvert()
    
    If m_IPicture_VTable Then
        
        Call SetVTableEntry(m_IPicture_VTable + 32&, m_IPicture_Renderer)
        Call SetVTableEntry(m_IPicture_VTable + 64&, m_IPicture_Attributes)
        
        m_IPicture_VTable = 0&
    
    End If

End Sub

Private Sub SetVTableEntry(ByVal OldPtr As Long, ByVal newPtr As Long)

    Dim vProtect As Long

    If Not (newPtr = 0& Or OldPtr = 0&) Then
        
        Call VirtualProtect(OldPtr, 4&, PAGE_EXECUTE_READWRITE, vProtect)
        
        Call CopyMemory(ByVal OldPtr, newPtr, 4&)
        
        Call VirtualProtect(OldPtr, 4&, vProtect, vProtect)
    
    End If

End Sub

Private Function NewRender(ByVal this As IPicture, ByVal hdc As Long, _
                           ByVal x As Long, ByVal y As Long, _
                           ByVal cx As Long, ByVal cy As Long, _
                           ByVal xSrc As Long, ByVal ySrc As Long, _
                           ByVal cxSrc As Long, ByVal cySrc As Long, _
                           ByVal pRcBounds As Long) As Long
    Dim hBmp As Long
    Dim hSrcDC As Long

    hSrcDC = CreateCompatibleDC(0&)
    
    If hSrcDC <> 0& Then
    
        hBmp = SelectObject(hSrcDC, this.Handle)
        
        If hBmp <> 0& Then

            Call GdiAlphaBlend(hdc, x, y, cx, cy, hSrcDC, 0&, 0&, cx, cy, &H1FF0000)

            Call SelectObject(hSrcDC, hBmp)
        
        End If
        
        Call DeleteDC(hSrcDC)
    
    End If
    
End Function

Private Function NewAttributes(ByVal this As Long, ByRef pAttr As Long) As Long

    pAttr = PICTURE_TRANSPARENT
    
End Function
' ----==== http://www.vbforums.com/showthread.php?p=4939815#post4939815 ====----

